/**
 * Term.java Version 32l 8-Feb-1999
 * Copyright (c) 1997-2000 Kyushu University
 *
 * Updated 99-09-08
 **/

package mgtp;

import ptv.*;

public abstract class Term extends Term0 { // %%% public: PTV
  //String name; Term next,arg; int index;
  // %%% public: PTV
  public String name; public Term next; public Term arg; int index;
  // %%%
  Term() {}
  public String toString() {return "";}
  public String toString1() {return "";}
  public String toStr() {return "";} // %%% PTV
  Term ground() {return null;}
  Term vground(Term x) {return null;}
  Term vgroundL() {return null;}
  boolean match(Term x) {return false;}
  boolean vmatch(Term x) {return false;}
  boolean satisfied() {return false;}
  boolean subsumed() {return false;}
  boolean conflict() {return false;}
  boolean notsubsumed_ac(MGTP mg) {return false;}
  void setac(MGTP mg) {}
  //void satisfied(AConj ai) {}
  public void satisfied(AConj ai) {} // %%% public: PTV
  void leafProc(GTerm t, AConj ante) {}
  int ieval() {return 0;}
  boolean bind(Term x, FVar f) {return false;}
  GTerm indexBV(MGTP mg) {return null;}
  GTerm parse_indexBV(MGTP mg) {return null;}
}

abstract class GTerm extends Term {
  ACell pac,nac; TMNode up; CList Cls;
  GTerm() {}
  boolean satisfied() {
    //Counter.sat++;
    return pac.act;
  }
  boolean subsumed() {
    //Counter.subs++;
    return pac.act;
  }
  boolean conflict() {
    //Counter.conf++;
    return nac.act;
  }
  void setac(MGTP mg) {
    pac=mg.ac; 
  }
  boolean notsubsumed_ac(MGTP mg) {
    if (pac.act) return false;
    pac=mg.ac; // early activation
    if (nac.act) {
      mg.closed=true;
    };
    return true;
  }

  void onTM(MGTP mg) {
    //mg.pModel=new Model(this, mg.pModel);
    mg.pModel=true;
  }
  void ptv_onTM(MGTP mg) {
    //mg.pModel=new Model(this, mg.pModel);
    mg.pModel=true;
    //
    if(mg.brosnum!=0){
      mg.curGT=new GT(this,mg.curGT,mg.brosnum);
      mg.brosnum=0;
    } else {
      mg.curGT=new GT(this,mg.curGT);
    }
  }

  GTerm indexBV(MGTP mg) {return this;}
}

class SGTerm extends GTerm {
  GTerm atm; SLCnsq cns;
  SGTerm() {}
  SGTerm(GTerm t) {atm=t;}
  //  public String toString() {return "SGTerm:"+atm;}
  public String toString() {return ""+atm;}
  public String toStr() {return ""+atm.toStr();} // %%% PTV
  boolean satisfied() {
    //Counter.sat++;
    if (atm.pac.act) {cns.sel=1; return true;}
    else if (atm.nac.act) {cns.sel=-1; return true;}
    else return false;
  }
}

class SNGTerm extends SGTerm {
  SNGTerm(GTerm t) {atm=t;}
  //  public String toString() {return "SNGTerm:-"+atm;}
  public String toString() {return "-"+atm;}
  public String toStr() {return "-"+atm.toStr();} // %%% PTV
  boolean satisfied() {
    //Counter.sat++;
    if (atm.nac.act) {cns.sel=1; return true;}
    else if (atm.pac.act) {cns.sel=-1; return true;}
    else return false;
  }
}

class GNLiteral extends GTerm {
  GTerm atm;
  GNLiteral(GTerm t) {atm=t;}
  GNLiteral(GTerm t, CList cls) {atm=t; Cls=cls;}
  public String toString() {return "-"+atm;}
  public String toStr() {return "-"+atm.toStr();} // %%% PTV
  boolean match(GTerm x) {
    if (!(x instanceof GNLiteral)) return false;
    return atm.match(((GNLiteral)x).atm); }
  boolean satisfied() {
    //Counter.sat++;
    return atm.nac.act;
  }
  boolean subsumed() {
    //Counter.subs++;
    return atm.nac.act;
  }
  boolean conflict() {
    //Counter.conf++;
    return atm.pac.act;
  }
  void setac(MGTP mg) {
    atm.nac=mg.ac; 
  }
  boolean notsubsumed_ac(MGTP mg) {
    if (atm.nac.act) return false;
    atm.nac=mg.ac;
    if (atm.pac.act) {
      mg.closed=true; 
    };
    return true;
  }

  void onTM(MGTP mg) {
    if (atm instanceof GCTermF) {
      //Counter.onTM++; 
      TMNode n;
      n=atm.up;
      while (n!=mg.TM) {
        if (!n.ndac.act)n.ndac=mg.ac;
        n=n.up;
      }
    };
    //mg.nModel=new Model(this, mg.nModel);
    mg.nModel=true;
  }

  void ptv_onTM(MGTP mg) {
    if (atm instanceof GCTermF) {
      //Counter.onTM++; 
      TMNode n;
      n=atm.up;
      while (n!=mg.TM) {
        if (!n.ndac.act)n.ndac=mg.ac;
        n=n.up;
      }
    }
    //mg.nModel=new Model(this, mg.nModel);
    mg.nModel=true;
    //
    if(mg.brosnum!=0){
      mg.curGT=new GT(this,mg.curGT,mg.brosnum);
      mg.brosnum=0;
    } else {
      mg.curGT=new GT(this,mg.curGT);
    }
  }

  GTerm parse_indexBV(MGTP mg) {
    Counter.indexBV++;
    //Counter.index++;
    TMNode top=mg.TM;
  
    TMLeaf lf; TMNode n;
    TMNode.top_maxst=false;

    n=top.farray[atm.index];
    if (n!=null) {
      TMNode.createOn=false;
      lf=(TMLeaf)n.ixBVL(atm.arg);
    }
    else {
      TMNode topDR=top.downR;
      TMNode.createOn=true;
      if (topDR.gen!=mg.ac) {
	mg.rnl=new RNdList(topDR,mg.rnl);
      }
      n=top.farray[atm.index]=top.downR=topDR.right=
	new PTMNode(atm,top,topDR);
      lf=(TMLeaf)n.crDBVL(atm.arg);
    }
    if (TMNode.createOn) {
      //Counter.indexBVCR++;
      lf.term=(GTerm)atm; lf.term.up=lf;
      return lf.nlit=this;
    } else if (lf.nlit==null) {
      atm=lf.term; // essential!!
      return lf.nlit=this;
    } else return lf.nlit;
  }

}

class UATerm extends GTerm {
  UATerm(String s) {name=s; pac=nac=ACell.OFF;}
  public String toString() {return name;}
  public String toStr() {return name;} // %%% PTV
  Term ground() {return this;}
  Term vgroundL() {return this;}
  boolean match(Term x) {
    //Counter.match++;
    return this==x;
  }
  boolean vmatch(Term x) {return this==x;}
}

class ATerm extends Term {
  ATerm() {}
  ATerm(String s) {name=s;}
  ATerm(String s, int i) {name=s; index=i;}
  ATerm(String s, Term x) {name=s; next=x;}
  ATerm(String s, Term x, int i) {name=s; next=x; index=i;}
  public String toString() {return name+","+next;}
  public String toStr() {return name+","+next.toStr();} // %%% PTV
  public String toString1() {return name;}
  Term ground() {return new ATerm(name, next.ground(), index);}
  Term vground(Term x) {return new ATerm(name,x,index);}
  Term vgroundL() {return new ATermL(name,index);}
  boolean match(Term x) {
    if (name!=x.name) return false;
    return next.match(x.next);
  }
  boolean vmatch(Term x) {return name==x.name;}
  boolean bind(Term x, FVar f) { return next.bind(x.next,f); }
}

class ATermL extends ATerm {
  ATermL(String s) {name=s;}
  ATermL(String s, int i) {name=s; index=i;}
  public String toString() {return name;}
  public String toStr() {return name;} // %%% PTV
  Term ground() {return this;}
  Term vgroundL() {return this;}
  boolean match(Term x) {return name==x.name;}
  boolean bind(Term x, FVar f) {return false;}
}

class FVar extends Term {
  Term maxst;
  FVar() {index= -1;}
  FVar(String s) {name=s; index= -1;}
  FVar(String s, Term x) {name=s; next=x; index= -1;}
  public String toString() {return "?"+name+","+next;}
  public String toString1() {return "?"+name;}
  boolean match(Term x) {arg=x; return next.match(x.next);}
  boolean bind(Term x, FVar f) {
    if (this==f) {arg=x; return true;} else return next.bind(x.next,f); 
  }

}

class FVarL extends FVar {
  FVarL() {index= -1;}
  FVarL(String s) {name=s; index= -1;}
  public String toString() {return "?"+name;}
  boolean match(Term x) {arg=x; return true;}
  boolean bind(Term x, FVar f) {if (this==f) {arg=x; return true;}
                                else return false;} 
}

class AVar extends FVar {
  AVar(String s) {name=s; index= -1;}
  AVar(String s, Term x) {name=s; next=x; index= -1;}
  public String toString() {return name+","+next;}
  boolean match(Term x) {return next.match(x.next);}
  boolean bind(Term x, FVar f) {
    return next.bind(x.next,f); 
  }

}

class AVarL extends FVarL {
  AVarL(String s) {name=s; index= -1;}
  public String toString() {return name;}
  boolean match(Term x) {return true;}
  boolean bind(Term x, FVar f) {return false;} 
}

class BVar extends Term {
  BVar() {index= -2;}
  BVar(String s, Term t) {name=s; arg=t; index= -2;}
  BVar(String s, Term t, Term x) {name=s; arg=t; next=x; index= -2;}
  public String toString() {return "!"+name+","+next;}
  public String toString1() {return "!"+name;}
  Term ground() {return arg.arg.vground(next.ground());}
  boolean match(Term x) {
    if (!arg.arg.vmatch(x)) return false;
    return next.match(x.next);
  }
  int ieval() {return ((ITerm)arg.arg).val;}
  boolean bind(Term x, FVar f) { return next.bind(x.next,f); }
}

class BVarL extends BVar {
  BVarL(String s, Term t) {name=s; arg=t; index= -2;}
  public String toString() {return "!"+name;}
  GTerm ground(TMNode tm) {return (GTerm)arg.arg;}
  Term ground() {return arg.arg.vgroundL();}
  boolean match(Term x) {return arg.arg.vmatch(x);}
  boolean bind(Term x, FVar f) {return false;}
}

class CTerm extends Term {
  int arity;
  CTerm() {}
  CTerm(String s, int i) {name=s; index=i;}
  CTerm(String s, int i, int ar) {name=s; index=i; arity=ar;}
  CTerm(String s, Term a, Term x) {name=s; arg=a; next=x;}
  CTerm(String s, Term a, int i) {name=s; arg=a; index=i;}
  CTerm(String s, Term a, int i, int ar)
    {name=s; arg=a; index=i; arity=ar;}
  CTerm(String s, Term a, Term x, int i) {name=s; arg=a; next=x; index=i;}
  CTerm(String s, Term a, Term x, int i, int ar) 
    {name=s; arg=a; next=x; index=i; arity=ar;}
  public String toString() {
    return name.substring(0,name.indexOf("/"))+"("+arg+"),"+next;
    //    return name+"("+arg+"),"+next;
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+
      "("+arg.toStr()+"),"+next.toStr();
  }
  public String toString1() {
    return "CTerm:"+name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  Term ground() 
    {return new CTerm(name, arg.ground(), next.ground(), index, arity);}
  Term vground(Term x) {return new CTerm(name,arg,x,index,arity);}
  Term vgroundL() {return new CTermL(name,arg,index,arity);}
  boolean match(Term x) {
    if (name!=x.name) return false;
    if (!arg.match(x.arg)) return false;
    return next.match(x.next);
  }
  boolean vmatch(Term x) {
    if (name!=x.name) return false;
    return arg.match(x.arg);
  }
  boolean bind(Term x, FVar f) { if (arg.bind(x.arg,f)) return true;
                                 return next.bind(x.next,f); }
}

class CTermL extends CTerm {
  CTermL(String s, int i) {name=s; index=i;}
  CTermL(String s, int i, int ar) {name=s; index=i; arity=ar;}
  CTermL(String s, Term a) {name=s; arg=a;}
  CTermL(String s, Term a, int i) {name=s; arg=a; index=i;}  
  CTermL(String s, Term a, int i, int ar) {name=s; arg=a; index=i; arity=ar;}  
  public String toString() {
    return name.substring(0,name.indexOf("/"))+"("+arg+")";
    //    return name+"("+arg+")"; // for debug bind
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";
  }
  public String toString1() {
    return "CTermL:"+name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  Term ground() {return new CTermL(name, arg.ground(),index,arity);}
  boolean match(Term x) {
    if (name!=x.name) return false;
    return arg.match(x.arg);
  }
  boolean bind(Term x, FVar f) { return arg.bind(x.arg,f); }
}

class CCTerm extends CTerm {
  TMNode anode;
  CCTerm() {}
  CCTerm(String s, int i) {name=s; index=i;}
  CCTerm(String s, int i, int ar) {name=s; index=i; arity=ar;}
  CCTerm(String s, Term a, Term x) {name=s; arg=a; next=x;}
  CCTerm(String s, Term a, int i) {name=s; arg=a; index=i;}
  CCTerm(String s, Term a, int i, int ar) {name=s; arg=a; index=i; arity=ar;}
  CCTerm(String s, Term a, Term x, int i) {name=s; arg=a; next=x; index=i;}
  CCTerm(String s, Term a, Term x, int i, int ar) 
    {name=s; arg=a; next=x; index=i; arity=ar;}
  public String toString() {
    //    return "CCTerm:"+name.substring(0,name.indexOf("/"))+
    //      "("+arg+"),"+next;
    return name.substring(0,name.indexOf("/"))+"("+arg+"),"+next;
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+
      "("+arg.toStr()+"),"+next.toStr();
  }
  public String toString1() {
    return "CCTerm:"+name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  Term ground() {
   Term t=new CTerm(name, arg.ground(), next.ground(), index, arity); 
   if (anode!=null) {
     anode.sterm=t;
     anode=null; // essential!
   }
   return t;
  }
}

class CCTermL extends CCTerm {
  CCTermL(String s, int i) {name=s; index=i;}
  CCTermL(String s, int i, int ar) {name=s; index=i; arity=ar;}
  CCTermL(String s, Term a) {name=s; arg=a;}
  CCTermL(String s, Term a, int i) {name=s; arg=a; index=i;}
  CCTermL(String s, Term a, int i, int ar) {name=s; arg=a; index=i; arity=ar;}
  public String toString() {
    //    return "CCTermL:"+name.substring(0,name.indexOf("/"))+"("+arg+")";
    return name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";
  }
  public String toString1() {
    return "CCTermL:"+name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  Term ground() {
    Term t=new CTermL(name, arg.ground(), index, arity);
    if (anode!=null) {
      anode.sterm=t;
      anode=null; // essential!
    }
    return t;
  }
}

class CTermF extends CTerm {
  CList Cls;
  CTermF() {}
  CTermF(String s, Term a) {name=s; arg=a;}
  CTermF(String s, int i) {name=s; index=i;}
  CTermF(String s, int i, int ar) {name=s; index=i; arity=ar;}
  CTermF(String s, Term a, int i) {name=s; arg=a; index=i;}
  CTermF(String s, Term a, int i, int ar) 
    {name=s; arg=a; index=i; arity=ar;}
  CTermF(String s, int i, CList cls) {name=s; index=i; Cls=cls;}
  CTermF(String s, int i, CList cls, int ar) 
    {name=s; index=i; Cls=cls; arity=ar;}
  CTermF(String s, Term a, int i, CList cls) {
    name=s; arg=a; index=i; Cls=cls;
  }
  CTermF(String s, Term a, int i, CList cls, int ar) {
    name=s; arg=a; index=i; Cls=cls; arity=ar;
  }
  public String toString() {
    return name.substring(0,name.indexOf("/"))+"("+arg+")";
    //    return name+"("+arg+")";
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";
  }
  Term ground() {return new GCTermF(name, arg.ground(), index, Cls, arity);}
  boolean match(Term x) {
    if (name!=x.name) return false;
    return arg.match(x.arg);
  }


  public void satisfied(AConj ai) { // %%% public: PTV
    //Counter.matchTM++;
    TMNode son=ai.tmn.farray[index];
    if (son!=null&&son.ndac.act) {
      Counter.matchtmBV++;
      son.matchTMBV(this,ai);
    }
  }

  void leafProc(GTerm t, AConj ante) {
    //Counter.leafProc++;
    if (t.pac.act) {
      //Counter.leafact++;
      if (ante.tl==null) {
	//Counter.putBuf++;
	ante.cnsq.putBuf(ante.mgtp);
      } else {
	ante.tl.hd.satisfied(ante.tl);
      }
    }
  }

  boolean bind(Term x, FVar f) {
    return arg.bind(x.arg,f); }  

  GTerm indexBV(MGTP mg) {
    Counter.indexBV++;
    //Counter.index++;
    TMNode top=mg.TM;

    TMLeaf lf; TMNode n;
    TMNode.top_maxst=false;

    n=top.farray[index];
    if (n!=null) {
      TMNode.createOn=false;
      lf=(TMLeaf)n.ixBVL(arg);
    }
    else {
      TMNode topDR=top.downR;
      TMNode.createOn=true;
      if (topDR.gen!=mg.ac) {
	mg.rnl=new RNdList(topDR,mg.rnl);
      }
      n=top.farray[index]=top.downR=topDR.right=
	new PTMNode(this,top,topDR);
      lf=(TMLeaf)n.crDBVL(arg);
    }
    if (TMNode.createOn) {
      //Counter.indexBVCR++;
      //Counter.groundTM++;
      lf.term=(GTerm)ground();
      lf.term.up=lf;
    }
    return lf.plit=lf.term;
  }

}

class NCTermF extends CTermF {
  NCTermF(String s, Term a) {name=s; arg=a;}
  NCTermF(String s, int i) {name=s; index=i;}
  NCTermF(String s, int i, int ar) 
    {name=s; index=i; arity=ar;}
  NCTermF(String s, Term a, int i) {name=s; arg=a; index=i;}
  NCTermF(String s, Term a, int i, int ar) 
    {name=s; arg=a; index=i; arity=ar;}
  NCTermF(String s, int i, CList cls) {name=s; index=i; Cls=cls;}
  NCTermF(String s, int i, CList cls, int ar) 
    {name=s; index=i; Cls=cls; arity=ar;}
  NCTermF(String s, Term a, int i, CList cls) {
    name=s; arg=a; index=i; Cls=cls;
  }
  NCTermF(String s, Term a, int i, CList cls, int ar) {
    name=s; arg=a; index=i; Cls=cls; arity=ar;
  }
  public String toString() {
    //    return "NCTermF:-"+name.substring(0,name.indexOf("/"))+
    //      "{"+index+"}"+"("+arg+")";
    return "-"+name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";
  }
  boolean match(Term x) {
    if (!(x instanceof GNLiteral)) return false;
    if (((GNLiteral)x).atm.name!=name) return false;
    return arg.match(((GNLiteral)x).atm.arg);
  }

  void leafProc(GTerm t, AConj ante) {
    //Counter.leafProc++;
    if (t.nac.act) {
      //Counter.leafact++;
      if (ante.tl==null) {
	//Counter.putBuf++;
	ante.cnsq.putBuf(ante.mgtp);
      } else {
	ante.tl.hd.satisfied(ante.tl);
      }
    }
  }

  boolean bind(Term x, FVar f) { return arg.bind(((GNLiteral)x).atm.arg,f); }

  GTerm indexBV(MGTP mg) {
    Counter.indexBV++;
    //Counter.index++;
    TMNode top=mg.TM;

    TMLeaf lf; TMNode n;
    TMNode.top_maxst=false;

    n=top.farray[index];
    if (n!=null) {
      TMNode.createOn=false;
      lf=(TMLeaf)n.ixBVL(arg);
    }
    else {
      TMNode topDR=top.downR;
      TMNode.createOn=true;
      if (topDR.gen!=mg.ac) {
	mg.rnl=new RNdList(topDR,mg.rnl);
      }
      n=top.farray[index]=top.downR=topDR.right=
	new PTMNode(this,top,topDR);
      lf=(TMLeaf)n.crDBVL(arg);
    }
    if (TMNode.createOn) {
      //Counter.indexBVCR++;
      //Counter.groundTM++;
      lf.term=(GTerm)ground();
      lf.term.up=lf;
    }
    if (lf.nlit==null)
      return lf.nlit= new GNLiteral(lf.term,Cls);
    return lf.nlit;
  }

}

class SCTermF extends CTermF {
  SLCnsq cns;
  SCTermF() {}
  SCTermF(String s, Term a, int i) {name=s; arg=a; index=i;}
  SCTermF(String s, Term a, int i, int ar) 
    {name=s; arg=a; index=i; arity=ar;}
  public String toString() {
    //    return "SCTermF:"+name.substring(0,name.indexOf("/"))+
    //      "{"+index+"}"+"("+arg+")";
    return name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";
  }
  void leafProc(GTerm t, AConj ante) {
    if (t.pac.act) {
      cns.sel=1; 
      //Counter.putBuf++;
      cns.putBuf(null);
      if (t.nac.act) System.out.println("ERROR!!");
    }
    else if (t.nac.act) {
      cns.sel=-1; 
      //Counter.putBuf++;
      cns.putBuf(null);
    }
  }
}

class SNCTermF extends SCTermF {
  SNCTermF(String s, Term a, int i) {name=s; arg=a; index=i;}
  SNCTermF(String s, Term a, int i, int ar)
    {name=s; arg=a; index=i; arity=ar;}
  public String toString() {
    //    return "SNCTermF:-"+name.substring(0,name.indexOf("/"))+
    //      "{"+index+"}"+"("+arg+")";
    return "-"+name.substring(0,name.indexOf("/"))+"("+arg+")";
  }
  public String toStr() { // %%% PTV
    return "-"+name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";
  }
  void leafProc(GTerm t, AConj ante) {
    if (t.nac.act) {
      cns.sel=1; 
      //Counter.putBuf++;
      cns.putBuf(null);
    }
    else if (t.pac.act) {
      cns.sel=-1; 
      //Counter.putBuf++;
      cns.putBuf(null);
    }
  }
}

class GCTermF extends GTerm {
  int arity;
  GCTermF(String s, int i) {name=s; index=i; pac=nac=ACell.OFF;}
  GCTermF(String s, int i, int ar) 
    {name=s; index=i; pac=nac=ACell.OFF; arity=ar;}
  GCTermF(String s, Term a) {name=s; arg=a; pac=nac=ACell.OFF;}
  GCTermF(String s, Term a, int i) {
    name=s; arg=a; index=i; pac=nac=ACell.OFF;
  }
  GCTermF(String s, Term a, int i, int ar) {
    name=s; arg=a; index=i; pac=nac=ACell.OFF; arity=ar;
  }
  GCTermF(String s, Term a, int i, CList cls) {
    name=s; arg=a; index=i; pac=nac=ACell.OFF; Cls=cls;
  }
  GCTermF(String s, Term a, int i, CList cls, int ar) {
    name=s; arg=a; index=i; pac=nac=ACell.OFF; Cls=cls; arity=ar;
  }

  public String toString() {
    return name.substring(0,name.indexOf("/"))+"("+arg+")";
    //    return name+"("+arg+")";
  }
  public String toStr() { // %%% PTV
    return name.substring(0,name.indexOf("/"))+"("+arg.toStr()+")";}

  Term ground() {return this;}
  boolean match(Term x) {
    if (name!=x.name) return false;
    return arg.match(x.arg);
  }

  void onTM(MGTP mg) {
    //Counter.onTM++; 
    TMNode n;
    n=up;
    while (n!=mg.TM) {
      if (!n.ndac.act)n.ndac=mg.ac;
      n=n.up;
    }
    //mg.pModel=new Model(this, mg.pModel);
    mg.pModel=true;
  }

  void ptv_onTM(MGTP mg) {
    //Counter.onTM++; 
    TMNode n;
    n=up;
    while (n!=mg.TM) {
      if (!n.ndac.act)n.ndac=mg.ac;
      n=n.up;
    }
    //mg.pModel=new Model(this, mg.pModel);
    mg.pModel=true;
    //
    if(mg.brosnum!=0){
      mg.curGT=new GT(this,mg.curGT,mg.brosnum);
      mg.brosnum=0;
    } else {
      mg.curGT=new GT(this,mg.curGT);
    }
  }

  GTerm parse_indexBV(MGTP mg) {
    Counter.indexBV++;
    //Counter.index++;
    TMNode top=mg.TM;
  
    TMLeaf lf; TMNode n;
    TMNode.top_maxst=false;

    n=top.farray[index];
    if (n!=null) {
      TMNode.createOn=false;
      lf=(TMLeaf)n.ixBVL(arg);
    }
    else {
      TMNode topDR=top.downR;
      TMNode.createOn=true;
      if (topDR.gen!=mg.ac) {
	mg.rnl=new RNdList(topDR,mg.rnl);
      }
      n=top.farray[index]=top.downR=topDR.right=
	new PTMNode(this,top,topDR);
      lf=(TMLeaf)n.crDBVL(arg);
    }
    if (TMNode.createOn) {
      //Counter.indexBVCR++;
      lf.term=this;
      lf.term.up=lf;
    }
    return lf.plit=lf.term;
  }

}

// eof
