/**
 * PTVisualizer.java v.1.2 15-Apr-2000
 * Copyright (c) 1997-2000 Kyushu University
 **/


package ptv;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.util.*;
//
import mgtp.*;
import mgtpCS.*; 
import mm_mchk.*;
//import mm_rcmp.*;
import mm_rcmp32l.*; 
//

public class PTVisualizer extends Frame 
implements ActionListener,TextListener,ItemListener{
    
  MGTP0 mgtp;

  Panel p;
  Panel exec_panel;
  Panel e_but_panel;    
  Panel readf_panel;
  Panel readf1_panel;
  Panel zoom_panel;
  Panel z_but_panel;
  Panel z_txt_panel;
  Panel z_txt_h_panel;
  Panel z_txt_v_panel;
  Panel cv_panel;   
  Panel s_but_panel;

  MenuBar menuBar;
  Choice zoomChoice;
  //
  Menu infengineMenu;
  Menu dspMenu;
  Menu treeMenu;
  Menu optionMenu;
  //
  Menu miscMenu;
  MenuItem params;
  Menu nodetype;

  Menu fontmenu;
  Menu fsizemenu;
  Menu ncolormenu;
  Menu lcolormenu;
  Menu repmenu; 

  CheckboxMenuItem subnt_circ,subnt_text;
  CheckboxMenuItem fonts[],fsizes[],ncolors[],lcolors[];

  String fontNames[]={
    "TimesRoman", "Courier", "Helvetica", "Serif","Dialog",
    "ScanSerif","Monospaced"
  };
  String fsizeNames[]={
    "10","12","14","16","18","20","22","24","26","28","30","32"
  };
  int fsizeValues[]={
    10,12,14,16,18,20,22,24,26,28,30,32
  };
  String colorNames[]={
    "black","blue","cyan","darkGray","gray","green","lightGray",
    "magenta","orange","pink","red","white","yellow"
  };
  Color colorValues[]={
    Color.black,Color.blue,Color.cyan,Color.darkGray,Color.gray,
    Color.green,Color.lightGray,Color.magenta,Color.orange,
    Color.pink,Color.red,Color.white,Color.yellow
  };
  

  String repNames[]={
    "0","1","2","5","10","20","50","100","200","500",
    "1000","2000","5000","10000","20000","50000","100000"
  };
  int repValues[]={
    0,1,2,5,10,20,50,100,200,500,1000,2000,5000,
    10000,20000,50000,100000
  };

  //
  CheckboxMenuItem ie_mgtp,ie_mgtpCS,ie_mm_mchk,
    //    ie_mm_rcmp,
    ie_mm_rcmp32l; 
  CheckboxMenuItem t_fixed,t_weighted;
  CheckboxMenuItem d_tree,d_radial,d_rad_local,d_disable;
  CheckboxMenuItem o_verbose,o_allSol,o_selectMin,o_compileExt;
  CheckboxMenuItem reps[]; 
  //
  Button run_button;
  Button readf_button;
  Button susp_button;
  Button status_button;
  Button quit_button; 
  Button dsp_button;  
  Button zoom_button; 
  Button reset_button;

  TextField readf_txt;
  TextField zoom_h_txt;
  TextField zoom_v_txt;
  boolean readf_txt_flag=false;
  //
  float zoom_h_val=(float)1; 
  float zoom_v_val=(float)1; 
  boolean zoom_h_flag=true;
  boolean zoom_v_flag=true;
  //
  String fil1;
  //  String dir1="c:\\mydocu~1\\jprob";
  String dir1;
  
  public static PTCanvas ptc;
  static int cvw_height=580;		
  static int cvw_width=780;

  static int lgw_height=cvw_height;		
  static int lgw_width=cvw_width;
  static int cur_select_zoom=0;
  static int old_select_zoom=0;

  static int guiw_height=cvw_height+140;
  static int guiw_width=cvw_width+40;

  public ProveT pt;
  Thread dspt=null; 
  Thread drwpt=null;
  //
  public static GT rootGT; 
  public static int max_gene; 
  //
  boolean sus=false;
  boolean run=false;
  boolean quit=false; 
  long exectime=0;    
  //
  char cursor_state='n';
  char tree_mode='f';
  char disp_mode='t';
  char menu_disp_mode='t'; 
  char menu_tree_mode='f'; 
  boolean drawStyle_changed=false; 
  boolean wsize_changed=false;     // %%%
  boolean resized_while_run=false; // %%%
  //
  char pickup='f'; // FIFO
  char infengine='m'; // MGTP
  //
  String repnumS="0";
  //  
  STWindow stwindow;

    
  PTVisualizer() {}

  public static void main(String Args[]) {
    //    setPriority(Thread.MAX_PRIORITY);
    PTVisualizer ptvis=new PTVisualizer();
    ptvis.init(); 
    //ptvis.show();
    ptvis.setVisible(true);
      
  }

  void init() {
    setTitle("Proof Tree Visualizer");
    //    setLayout(new BorderLayout());
    //
    setBackground(Color.lightGray);
    setForeground(Color.black);

    /*** Menu Bar ***/

    /** Anonymous Mene **/
    //
    menuBar=new MenuBar();
    zoomChoice=new Choice();
    zoomChoice.addItem("X1");
    zoomChoice.addItem("X2");    
    zoomChoice.addItem("X4");
    zoomChoice.addItem("X10");
    zoomChoice.addItem("X50");
    zoomChoice.addItem("X100");
    zoomChoice.addItem("Custom");
    zoomChoice.addItemListener(this);

    /** Engine Menu **/
    //
    infengineMenu=new Menu("Engine");
    ie_mgtp=new CheckboxMenuItem("MGTP",true);
    ie_mgtpCS=new CheckboxMenuItem("MGTP-CS",false);
    ie_mm_mchk=new CheckboxMenuItem("MM-Mchk",false);
    //    ie_mm_rcmp=new CheckboxMenuItem("MM-Rcmp",false);
    //    ie_mm_rcmp32l=new CheckboxMenuItem("MM-Rcmp32l",false);
    ie_mm_rcmp32l=new CheckboxMenuItem("MM-Rcmp",false);
    ie_mgtp.addItemListener(this);
    ie_mgtpCS.addItemListener(this);
    ie_mm_mchk.addItemListener(this);
    //    ie_mm_rcmp.addItemListener(this);
    ie_mm_rcmp32l.addItemListener(this);
    infengineMenu.add(ie_mgtp);
    infengineMenu.add(ie_mgtpCS);
    infengineMenu.add(ie_mm_mchk);
    //    infengineMenu.add(ie_mm_rcmp);
    infengineMenu.add(ie_mm_rcmp32l);
    menuBar.add(infengineMenu);

    /** Option Menu **/
    //
    optionMenu=new Menu("Option");
    o_verbose=new CheckboxMenuItem("Verbose",false);
    o_allSol=new CheckboxMenuItem("All Solve",false);
    o_selectMin=new CheckboxMenuItem("Select Min",false);
    o_compileExt=new CheckboxMenuItem("Compile Ext",false);

    Menu repmenu = new Menu("Repeat");
    reps = new CheckboxMenuItem[repNames.length];
    for (int i=0; i<reps.length; i++) {
      reps[i]=new CheckboxMenuItem(repNames[i],false);
      repmenu.add(reps[i]);
      reps[i].addItemListener(this);
    }

    optionMenu.add(o_verbose);
    optionMenu.add(o_allSol);
    optionMenu.add(o_selectMin);
    optionMenu.add(o_compileExt);
    optionMenu.add(repmenu);

    menuBar.add(optionMenu);
   
    /** Display Menu **/
    //
    dspMenu=new Menu("Display");
    d_tree=new CheckboxMenuItem("Tree",true);
    d_radial=new CheckboxMenuItem("Radial(Global)",false);
    d_rad_local=new CheckboxMenuItem("Radial(Local)",false);
    d_disable=new CheckboxMenuItem("Disable",false);
    d_tree.addItemListener(this);
    d_radial.addItemListener(this);
    d_rad_local.addItemListener(this);
    d_disable.addItemListener(this);
    dspMenu.add(d_tree);
    dspMenu.add(d_radial);
    dspMenu.add(d_rad_local);
    dspMenu.add(d_disable);

    menuBar.add(dspMenu);

    /** Option Menu **/
    //
    treeMenu=new Menu("Alloc");
    t_weighted=new CheckboxMenuItem("Weighted",false);
    t_fixed=new CheckboxMenuItem("Fixed",true);
    t_weighted.addItemListener(this);
    t_fixed.addItemListener(this);
    
    treeMenu.add(t_fixed);
    treeMenu.add(t_weighted);

    menuBar.add(treeMenu);

    /** Misc Menu **/    	
    //
    miscMenu=new Menu("Misc");
    params=new MenuItem("params");
    params.addActionListener(this);
    miscMenu.add(params);

    nodetype=new Menu("Nodetype");
    miscMenu.add(nodetype);
    subnt_circ=new CheckboxMenuItem("Circle",false);
    subnt_text=new CheckboxMenuItem("Text",false);
    nodetype.add(subnt_circ);
    nodetype.add(subnt_text);
    subnt_circ.addItemListener(this);
    subnt_text.addItemListener(this);

    fontmenu=new Menu("Font");
    fonts=new CheckboxMenuItem[fontNames.length];
    for (int i=0; i<fonts.length; i++) {
      fonts[i]=new CheckboxMenuItem(fontNames[i],false);
      fontmenu.add(fonts[i]);
      fonts[i].addItemListener(this);
    }
    fsizemenu=new Menu("Font Size");
    fsizes=new CheckboxMenuItem[fsizeNames.length];
    for (int i=0; i<fsizes.length; i++) {
      fsizes[i]=new CheckboxMenuItem(fsizeNames[i],false);
      fsizemenu.add(fsizes[i]);
      fsizes[i].addItemListener(this);
    }
    ncolormenu=new Menu("Node Color");
    ncolors=new CheckboxMenuItem[colorNames.length];
    for (int i=0; i<ncolors.length; i++) {
      ncolors[i]=new CheckboxMenuItem(colorNames[i],false);
      ncolormenu.add(ncolors[i]);
      ncolors[i].addItemListener(this);
    }
    lcolormenu=new Menu("Line Color");
    lcolors=new CheckboxMenuItem[colorNames.length];
    for (int i=0; i<lcolors.length; i++) {
      lcolors[i]=new CheckboxMenuItem(colorNames[i],false);
      lcolormenu.add(lcolors[i]);
      lcolors[i].addItemListener(this);
    }

    miscMenu.add(fontmenu);
    miscMenu.add(fsizemenu);
    miscMenu.add(ncolormenu);
    miscMenu.add(lcolormenu);

    menuBar.add(miscMenu);

    setMenuBar(menuBar);


    /*** Panel, Button, Text Field ***/
    //
    p=new Panel(new FlowLayout());

    /** Exec Panel **/
    //
    exec_panel=new Panel(new BorderLayout());

    dsp_button=new Button("Dsp");     
    dsp_button.addActionListener(this);
    run_button=new Button("Run");
    run_button.addActionListener(this);
    susp_button=new Button("Suspend");
    susp_button.addActionListener(this);
    quit_button=new Button("Quit");      
    quit_button.addActionListener(this); 
    status_button=new Button("Status");
    status_button.addActionListener(this);

    readf_button=new Button("Read File");
    readf_button.addActionListener(this);
    readf_txt=new TextField("", 20);
    readf_txt.addTextListener(this);
    //
    default_textF_color(readf_txt); 

    /* Exec Button Panel */

    Panel eb_panel = new Panel();
    eb_panel.add(dsp_button);
    eb_panel.add(run_button);
    eb_panel.add(susp_button);
    eb_panel.add(quit_button);
    eb_panel.add(status_button);


    /* Read File panel */

    Panel rf_panel=new Panel();
    rf_panel.add(readf_button);
    rf_panel.add(readf_txt);

    /* Layout */

    exec_panel.add(eb_panel,BorderLayout.NORTH);
    exec_panel.add(rf_panel,BorderLayout.SOUTH);


    /** Zoom Panel **/
    //
    zoom_panel=new Panel(new BorderLayout());

    z_but_panel=new Panel();
    z_txt_panel=new Panel();
    z_txt_h_panel=new Panel(new BorderLayout());
    z_txt_v_panel=new Panel(new BorderLayout());

    cv_panel=new Panel(new BorderLayout());
    s_but_panel=new Panel();

    setResizable(true);

    add(cv_panel);

    p.add(exec_panel,"West");
    p.add(zoom_panel,"Center");
    p.add(s_but_panel,"East");
    
    zoom_panel.add(z_but_panel,"North");
    zoom_panel.add(z_txt_panel,"South");

    zoom_button=new Button("Zoom"); 
    zoom_button.addActionListener(this);
    z_but_panel.add(zoom_button); 
    //
    z_but_panel.add(zoomChoice);
    reset_button=new Button( "Reset ");
    reset_button.addActionListener(this);
    z_but_panel.add(reset_button);
        
    z_txt_panel.add(z_txt_h_panel);
    z_txt_panel.add(z_txt_v_panel);
    Label zoom_h_label=new Label(" mult H ",Label.CENTER);
    Label zoom_v_label=new Label(" mult V ",Label.CENTER);
    zoom_h_txt=new TextField("", 5);
    zoom_v_txt=new TextField("", 5);

    zoom_h_txt.addTextListener(this); 
    zoom_v_txt.addTextListener(this); 
    
    //
    default_textF_color(zoom_h_txt);
    default_textF_color(zoom_v_txt);
    //
    z_txt_h_panel.add(zoom_h_label,"West");
    z_txt_h_panel.add(zoom_h_txt,"East");
    z_txt_v_panel.add(zoom_v_label,"West");
    z_txt_v_panel.add(zoom_v_txt,"East");
    

    /*** PT Canvas ***/
    //
    ptc=new PTCanvas(cvw_width,cvw_height,lgw_width,lgw_height,this);

    ptc.h=new Scrollbar(Scrollbar.HORIZONTAL);
    ptc.v=new Scrollbar(Scrollbar.VERTICAL);
    //    	
    cv_panel.add(p,"North");
    cv_panel.add(new Panel(),"West");
    //
    cv_panel.add(ptc.v,"East");
    cv_panel.add(ptc.h,"South");
    cv_panel.add(ptc,"Center");

    ptc.setBackground(new Color(230,230,240));
    ptc.setSize(cvw_width,cvw_height);

    //ptc.setResizable(true);

    setSize(guiw_width,guiw_height);
    addWindowListener(new PTWindowListener());
    ptc.h.setValues(0,cvw_width,0,cvw_width);
    ptc.v.setValues(0,cvw_height,0,cvw_height);
    ptc.h.addAdjustmentListener(ptc);
    ptc.v.addAdjustmentListener(ptc);

    zoom_h_txt.setEnabled(true);
    zoom_v_txt.setEnabled(true);
        
    run_button.setEnabled(false);
    susp_button.setEnabled(false);
    quit_button.setEnabled(false);
    zoom_h_txt.setText(Float.toString(ptc.cur_mult_h));
    zoom_v_txt.setText(Float.toString(ptc.cur_mult_v));
        
  }


  public void adjustCanvasWindowSize() { 
    guiw_height = getHeight();
    guiw_width = getWidth();
    //System.out.println("guiw_height: "+guiw_height+
    //		       " guiw_width: "+guiw_width);
    if (cvw_height!=ptc.getHeight()) wsize_changed=true; 
    if (cvw_width!=ptc.getWidth()) wsize_changed=true; 
    cvw_height = ptc.getHeight();
    cvw_width = ptc.getWidth();
    //System.out.println("height: "+cvw_height+
    //		       " width: "+cvw_width);
    ptc.cvw_height = cvw_height; 
    ptc.cvw_width = cvw_width;
    wsize_changed=true; // %%%
  }
  //

  public void default_textF_color(TextField t) {
    t.setForeground(Color.black);
    t.setBackground(new Color(230,230,240));
  }
  public void default_textA_color(TextArea t) {
    t.setForeground(Color.black);
    t.setBackground(new Color(230,230,240));
  }



  public void actionPerformed(ActionEvent e) {
    if (e.getSource()==readf_button) {
      readf_button_Clicked();
      return;
    } 
    else if (e.getSource()==dsp_button) {
      dsp_button_Clicked();
      return;
    } 
    else if (e.getSource()==run_button) {
      run_button_Clicked();
      return;
    } 
    else if (e.getSource()==quit_button) {
      quit_button_Clicked();
      return;
    } 
    else if (e.getSource()==susp_button) {
      // susp_button is a toggle switch

      if (stwindow!=null) stwindow.displaystatus(); // %%%
      
      if (sus) { // if the execution is suspended then resume it
	//System.out.println("Resumed!");
	pt.gtc.resu();
	pt.gtc.ntfy(); 
	//	readf_txt.setText(fil1); // %%%
	//	readf_txt.setEnabled(false);
	readf_button.setEnabled(false);
	susp_button.setLabel("Suspend");
	sus=false;
	run_button.setEnabled(false);
	run=true;

      }
      else { // if running then suspend it
	ptc.flush();
	pt.gtc.sus(); 
	//System.out.println("Suspended!");
	run_button.setEnabled(true);
	//readf_txt.setEnabled(true);
	readf_button.setEnabled(true);
	run=false;
	ptc.zoom_redraw=false;
	susp_button.setLabel("Resume");
	sus=true;
	susp_button.setEnabled(true);
      }
    } 
    else if(e.getSource()==reset_button) {
      //System.out.println("reset_button selected mgtp:"+mgtp+
      //			 " rootGT:"+rootGT);
      if (ptc.zoom_select) { // ### Currently NOP
	//System.out.println("reset 1: zoom_select=true run="+run);
	ptc.zoom_select=false;
	reset_button.setLabel("Reset");
	ptc.setCursor(ptc.cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	ptc.cur_mult_h=ptc.old_mult_h;
	ptc.cur_mult_v=ptc.old_mult_v;
	zoom_h_txt.setText(Float.toString(ptc.cur_mult_h));
	zoom_v_txt.setText(Float.toString(ptc.cur_mult_v));
	cur_select_zoom=old_select_zoom;
	zoomChoice.select(cur_select_zoom);
      } 
      else {
	if (run==false && mgtp!=null && rootGT!=null) { // ###
	  //System.out.println("reset 2: zoom_select=false run="+run);
	  reset_button.setEnabled(false); // ###
	  ptc.zoomReset();
	  ptc.coordinate_offScr(ptc.gt);
	  // %%%
	  ptc.drwc=0;
	  if (sus) ptc.gt.zoom_Reset(ptc,ptc.curGT); 
	  else {
	    //System.out.println("zoom_Redraw in reset 2");
	    ptc.gt.zoom_Reset(ptc);
	  }
	  // %%%
	  ptc.flush();
	  reset_button.setEnabled(true); // ###
	  zoom_button.setEnabled(true); // ###
	} 
	else if (run==true) {
	  //System.out.println("reset 3: zoom_select=false run="+run);
	  ptc.zoomReset();
	  ptc.zoom_redraw=true;
	  ptc.mouse_x=-1;ptc.mouse_y=-1;
	}
      }
    }
    else if (e.getSource()==zoom_button) {
      //System.out.println("zoom_button selected mgtp:"+mgtp+
      //		 " rootGT:"+rootGT);
      if (mgtp!=null && rootGT!=null) { // ###
	if (zoom_h_flag && zoom_v_flag) {
	  zoom_button.setEnabled(false); // ###
	  ptc.cur_mult_h=zoom_h_val;
	  ptc.cur_mult_v=zoom_v_val;
	  //	if (ptc.cur_mult_h!=ptc.old_mult_h ||  // ###
	  //	    ptc.cur_mult_v!=ptc.old_mult_v) {  // ###
	  ptc.zoom_select=true;
	  reset_button.setLabel("Cancel");
	  reset_button.setEnabled(true);
	  ptc.setCursor(ptc.cursor.
			getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
	  ptc.rect_width=(int)(cvw_width*ptc.old_mult_h/ptc.cur_mult_h+0.5);
	  ptc.rect_height=(int)(cvw_height*ptc.old_mult_v/ptc.cur_mult_v+0.5);
	  //	}  // ###
	} 
	else { 
	  zoom_h_txt.setText("1.0");
	  zoom_v_txt.setText("1.0");
	  zoom_h_val=(float)1;
	  zoom_v_val=(float)1;
	  zoom_h_flag=true;
	  zoom_v_flag=true;
	}
      } 
    } 
    else if (e.getSource()==status_button) {
      stwindow=new STWindow(mgtp,this,ptc);
    } 
    else if (e.getSource()==params) {
      ParamDialog paramsDialog=new ParamDialog(this);
      //paramsDialog.show();
      paramsDialog.setVisible(true);
    }

  }


  public void textValueChanged(TextEvent e) {
    if (e.getSource()==readf_txt) {
      if (readf_txt_flag) {
	//System.out.println("readf_txt changed. readf_txt= "+
	//			   readf_txt.getText()+" in FD");
      } 
      else {
	//System.out.println("readf_txt changed. readf_txt= "+
	//		   readf_txt.getText()+" directly");

	String curdir="";
	File fil=new File(".");
	String sd=fil.getAbsolutePath();
	int i=sd.lastIndexOf("/");
	if (i==-1) {curdir="";}
	else {
	  curdir=sd.substring(0,i+1);
	}
	//System.out.println("curdir: "+curdir);

	String s=readf_txt.getText();
	i=s.lastIndexOf("/");
	if (i==-1) {dir1=""; fil1=s;}
	else {
	  dir1=s.substring(0,i+1);
	  fil1=s.substring(i+1,s.length());
	}
	if (!(dir1.startsWith("/")||dir1.startsWith("~"))) {
	  dir1=curdir+dir1;
	}
	//System.out.println("dir1: "+dir1);

	File f=new File(dir1,fil1);

	boolean b=f.isFile() && f.canRead();  
	if (b) {
	  default_textF_color(readf_txt);
	  run_button.setEnabled(!run);
	} 
	else {
	  readf_txt.setForeground(Color.red);
	  run_button.setEnabled(false);
	}
      }
      readf_txt_flag=false;

    } 
    else if (e.getSource()==zoom_h_txt) { // %%%
      try {
	zoom_h_val=(Float.valueOf(zoom_h_txt.getText())).floatValue();
	zoom_h_flag=true;
      } catch(NumberFormatException nfe) {zoom_h_flag=false;}
    } 
    else if (e.getSource()==zoom_v_txt) { // %%%
      try {
	zoom_v_val=(Float.valueOf(zoom_v_txt.getText())).floatValue();
	zoom_v_flag=true;
      } catch(NumberFormatException nfe) {zoom_v_flag=false;}
    }
  }

  public void itemStateChanged(ItemEvent e) {
    float s; 
    if(e.getSource()==t_fixed) {
      //System.out.println("t_fixed selected: run="+run+" sus="+sus);
      menu_tree_mode='f'; 
      tree_exclusive_setState('f');
    } 
    else if (e.getSource()==t_weighted) {
      //System.out.println("t_weighted selected run="+run+" sus="+sus);
      menu_tree_mode='w'; 
      tree_exclusive_setState('w');
    } 
    else if (e.getSource()==d_tree) {
      //System.out.println("d_tree selected: run="+run+" sus="+sus);
      menu_disp_mode='t';
      ptc.execProve_mode=false;

      if (run) {
	if (disp_mode!='t') {
	  //System.out.println("%%% d_tree: cause DispModeException in GT");
	  disp_mode='t';
	  dsp_exclusive_setState('t');
	}
      } 
      else if (run==false && sus==true && mgtp!=null) {
	if (disp_mode!='t') {
	  //System.out.println("%%% redraw d_tree");
	  disp_mode='t';
	  dsp_exclusive_setState('t');

	  pt.gtc.redraw(); // turn on the redraw flag
	  pt.gtc.ntfy();   // to exit from wait-while

	}  
      } 
      else {
	//System.out.println("%%% not run & not sus: menu_disp_mode=t");
	dsp_exclusive_setState('t');
      }
    } 
    else if (e.getSource()==d_radial) {
      //System.out.println("d_radial selected: run="+run+" sus="+sus);
      menu_disp_mode='r';
      ptc.execProve_mode=false;

      if (run) {
	if (disp_mode!='r') {
	  //System.out.println("%%% d_radial: cause DispModeException in GT");
	  disp_mode='r';
	  dsp_exclusive_setState('r');
	}
      } 
      else if (run==false && sus==true && mgtp!=null) {
	if (disp_mode!='r') {
	  //System.out.println("%%% redraw d_rad");
	  disp_mode='r';
	  dsp_exclusive_setState('r');

	  pt.gtc.redraw(); // turn on the redraw flag
	  pt.gtc.ntfy();   // to exit from wait-while

	}  
      } 
      else {
	//System.out.println("%%% not run & not sus: menu_disp_mode=r");
	dsp_exclusive_setState('r');
      }
    } 
    else if (e.getSource()==d_rad_local) {
      //System.out.println("d_rad_local selected: run="+run+" sus="+sus);
      menu_disp_mode='l';  
      ptc.execProve_mode=false; 

      if (run) {
	if (disp_mode!='l') {
	  //System.out.println("%%% d_rad_local: "+
	  //	     "cause DispModeException in GT");
	  disp_mode='l';
	  dsp_exclusive_setState('l');
	}
      } 
      else if (run==false && sus==true && mgtp!=null) {
	if (disp_mode!='l') {
	  //System.out.println("%%% redraw d_rad_local");
	  disp_mode='l';
	  dsp_exclusive_setState('l');

	  pt.gtc.redraw(); // turn on the redraw flag
	  pt.gtc.ntfy();   // to exit from wait-while

	}  
      } 
      else {
	//System.out.println("%%% not run & not sus: menu_disp_mode=l");
	dsp_exclusive_setState('l');
      }
    } 
    else if (e.getSource()==d_disable) {
      //System.out.println("d_disable selected mgtp:"+mgtp+
      //		 " rootGT:"+rootGT); // ###
      ptc.execProve_mode=true;
      dsp_exclusive_setState('d');
    } 
    else if (e.getSource()==ie_mgtp) {
      //System.out.println("mgtp selected");
      ie_mgtp.setState(true);
      ie_mgtpCS.setState(false);
      ie_mm_mchk.setState(false);
      //      ie_mm_rcmp.setState(false);
      ie_mm_rcmp32l.setState(false);
      infengine='m';
    } 
    else if (e.getSource()==ie_mgtpCS) {
      //System.out.println("mgtpCS selected");
      ie_mgtp.setState(false);
      ie_mgtpCS.setState(true);
      ie_mm_mchk.setState(false);
      //      ie_mm_rcmp.setState(false);
      ie_mm_rcmp32l.setState(false);
      infengine='s';
    } 
    else if (e.getSource()==ie_mm_mchk) {
      //System.out.println("mm-mchk selected");
      ie_mgtp.setState(false);
      ie_mgtpCS.setState(false);
      ie_mm_mchk.setState(true);
      //      ie_mm_rcmp.setState(false);
      ie_mm_rcmp32l.setState(false);
      infengine='c';
    } 
    /*
    else if (e.getSource()==ie_mm_rcmp) {
      //System.out.println("mm-rcmp selected");
      ie_mgtp.setState(false);
      ie_mgtpCS.setState(false);
      ie_mm_mchk.setState(false);
      ie_mm_rcmp.setState(true);
      ie_mm_rcmp32l.setState(false);
      infengine='r';
    } 
    */
    else if (e.getSource()==ie_mm_rcmp32l) {
      //System.out.println("mm-rcmp32l selected");
      ie_mgtp.setState(false);
      ie_mgtpCS.setState(false);
      ie_mm_mchk.setState(false);
      //      ie_mm_rcmp.setState(false);
      ie_mm_rcmp32l.setState(true);
      infengine='l';
    } 
    else if (e.getSource()==zoomChoice) {
      //System.out.println("zoomChoice selected mgtp:"+mgtp+
      //		 " rootGT:"+rootGT);
      if (mgtp!=null && rootGT!=null) { // ###
	zoom_button.setEnabled(false); // ###
	cur_select_zoom=zoomChoice.getSelectedIndex();
	switch(cur_select_zoom) {
	case 0:
	  ptc.cur_mult_h=ptc.cur_mult_v=1;
	  break;
	case 1:
	  ptc.cur_mult_h=ptc.cur_mult_v=2;
	  break;
	case 2:
	  ptc.cur_mult_h=ptc.cur_mult_v=4;
	  break;    
	case 3:
	  ptc.cur_mult_h=ptc.cur_mult_v=10;
	  break;    
	case 4:
	  ptc.cur_mult_h=ptc.cur_mult_v=50;
	  break;    
	case 5:
	  ptc.cur_mult_h=ptc.cur_mult_v=100;
	  break;    
	case 6:
	  CMDialog cmDialog=new CMDialog(this);
	  cmDialog.show();
	  cmDialog.setVisible(true);
	  break;                         
	  //	default:
	}
	// ###
	//      if (ptc.cur_mult_h!=ptc.old_mult_h || 
	//      	  ptc.cur_mult_v!=ptc.old_mult_v) { 
	
	zoom_h_txt.setText(Float.toString(ptc.cur_mult_h));
	zoom_v_txt.setText(Float.toString(ptc.cur_mult_v));
	
	//	zoom_h_txt.setEnabled(true); // %%%
	//	zoom_v_txt.setEnabled(true); // %%%
	
	ptc.zoom_select=true;
	reset_button.setLabel("Cancel");
	reset_button.setEnabled(true);
	ptc.setCursor(ptc.cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
	ptc.rect_width=(int)(cvw_width*ptc.old_mult_h/ptc.cur_mult_h+0.5);
	ptc.rect_height=(int)(cvw_height*ptc.old_mult_v/ptc.cur_mult_v+0.5);
	//      } // ###
      } // ###
    }
    // ### 
    else if (e.getSource()==subnt_circ) {
      //System.out.println("subnt_circ clicked"+subnt_circ.getState());
      ptc.node_circ=true;
      subnt_circ.setState(true);
      subnt_text.setState(false);
      drawStyle_changed=true; // ###
    } 
    else if (e.getSource()==subnt_text) {
      //System.out.println("subnt_text clicked"+subnt_text.getState());
      ptc.node_circ=false;
      subnt_text.setState(true);
      subnt_circ.setState(false);
      drawStyle_changed=true; // ###
    }

    for (int i=0; i<fonts.length; i++) {
      int k=1; // default: fontNames[1]="Courier"
      if (e.getSource()==fonts[i]) {
	//System.out.println(fontNames[i]+" clicked"+
	//	   fonts[i].getState());
	if (fonts[i].getState()) {
	  ptc.font_type=fontNames[i];
	  k=i;
	}
	else ptc.font_type=ptc.font_type_default;
	drawStyle_changed=true; // ###
	//	ptc.node_font=new Font(fontNames[i],Font.PLAIN,ptc.font_size);
	ptc.node_font=new Font(ptc.font_type,Font.PLAIN,ptc.font_size);
	ptc.setFont(ptc.node_font);
	chkbox_exclusive_setState(k,fonts,fontNames);
	break;
      }
    }
    for (int i=0; i<fsizes.length; i++) {
      int k=3; // default: fsizeNames[3]="16"
      if (e.getSource()==fsizes[i]) {
	//System.out.println(""+fsizeValues[i]+" clicked"+
	//	   fsizes[i].getState());
	if (fsizes[i].getState()) {
	  ptc.font_size=fsizeValues[i];
	  k=i;
	}
	else ptc.font_size=ptc.font_size_default;
	drawStyle_changed=true; // ###
	//	ptc.node_font=new Font(ptc.font_type,
	//			       Font.PLAIN,fsizeValues[i]);
	ptc.node_font=new Font(ptc.font_type,Font.PLAIN,ptc.font_size);
	ptc.setFont(ptc.node_font);
	chkbox_exclusive_setState(k,fsizes,fsizeNames);
	break;
      }
    }
    for (int i=0; i<ncolors.length; i++) {
      int k=0; // default: colorNames[0]="black"
      if (e.getSource()==ncolors[i]) {
	//System.out.println("ncolor: "+colorNames[i]+" clicked"+
	//	   ncolors[i].getState());
	if (ncolors[i].getState()) {
	  ptc.node_color=colorValues[i];
	  k=i;
	}
	else ptc.node_color=ptc.node_color_default;
	drawStyle_changed=true; // ###
	chkbox_exclusive_setState(k,ncolors,colorNames);
	break;
      }
    }
    for (int i=0; i<lcolors.length; i++) {
      int k=0; // default: colorNames[0]="black"
      if (e.getSource()==lcolors[i]) {
	//System.out.println("lcolor: "+colorNames[i]+" clicked"+
	//	   lcolors[i].getState());
	if (lcolors[i].getState()) {
	  ptc.line_color=colorValues[i];
	  k=i;
	}
	else ptc.line_color=ptc.line_color_default;
	drawStyle_changed=true; // ###
	chkbox_exclusive_setState(k,lcolors,colorNames);
	break;
      }
    }
    for (int i=0; i<reps.length; i++) {
      if (e.getSource()==reps[i]) {
	//System.out.println(""+repNames[i]+" clicked: "+reps[i].getState());
	if (reps[i].getState()) repnumS=repNames[i];
	else repnumS=repNames[0];
	rep_exclusive_setState(i);
	// ###
	if (reps[i].getState()) {
	  //System.out.println("reps specified: -> disable");
	  ptc.execProve_mode=true;
	  dsp_exclusive_setState('d'); 
	}
	else {
	  //System.out.println("reps released: disable -> tree");
	  dsp_exclusive_setState('t'); 
	  ptc.execProve_mode=false;
	  menu_disp_mode='t';
	}
	// ###
	break;
      }
    }
    // ### 
    
  }


  void chkbox_exclusive_setState(int k,CheckboxMenuItem[] cb,String[] cbn ) {
    for (int i=0; i<cbn.length; i++)
      if (i==k) cb[i].setState(true);
      else cb[i].setState(false);
  }

  void rep_exclusive_setState(int k) {
    for (int i=0; i<repNames.length; i++)
      if (i==k && reps[i].getState()) reps[i].setState(true);
      else if (i!=k) reps[i].setState(false);
  }
      
  void tree_exclusive_setState(char c) {
    if (c=='f') t_fixed.setState(true);
    else t_fixed.setState(false);
    if (c=='w') t_weighted.setState(true);
    else t_weighted.setState(false);
  }

  void dsp_exclusive_setState(char c) {
    if (c=='t') d_tree.setState(true);
    else d_tree.setState(false);
    if (c=='r') d_radial.setState(true); 
    else d_radial.setState(false);
    if (c=='l') d_rad_local.setState(true);
    else d_rad_local.setState(false);
    if (c=='d') d_disable.setState(true);
    else d_disable.setState(false);
  }



  // ###
  void dsp_button_Clicked() {
    //System.out.println("%%% dsp_button clicked: run="+run+" sus="+sus);

    if (run==false && sus==false && rootGT!=null) {

      if ((menu_tree_mode==tree_mode && menu_disp_mode==disp_mode)
	   && !drawStyle_changed && !wsize_changed) return;

      //System.out.println("%%% dsp_button (draw): run="+run+" sus="+sus);

      tree_mode=menu_tree_mode;
      disp_mode=menu_disp_mode;
      drawStyle_changed=false;
      wsize_changed=false; // ###

      dsp_button.setEnabled(false); // ###
      dspMenu.setEnabled(false);
      treeMenu.setEnabled(false);
      //	ptc.og.dispose();

      ptc.drwc=0; // %%%
      ptc.coordinate_offScr(rootGT);

      if (tree_mode=='f') { // fixed

        if (disp_mode=='t') {
	  rootGT.step=(float)((cvw_height-ptc.top_margin-ptc.bot_margin)/
				   (max_gene+1.0));   // ###
	  rootGT.fixed_recalc(ptc.sid_margin,
			      cvw_width-ptc.sid_margin*2,ptc);
	}
	else if (disp_mode=='r') {

	  if (cvw_height<cvw_width) 
	    rootGT.step=(float)((cvw_height/2.0-ptc.top_margin)/
				(max_gene+1.0));   // %%%
	  else rootGT.step=(float)((cvw_width/2.0-ptc.top_margin)/
				   (max_gene+1.0)); // %%%

	  rootGT.r_fixed_recalc(0,(float)(Math.PI*2),ptc);
	}
	else if (disp_mode=='l') {

	  if (cvw_height<cvw_width) 
	    rootGT.step=(float)((cvw_height/2.0-ptc.top_margin)/
				     (max_gene+1.0));   // %%%
	  else rootGT.step=(float)((cvw_width/2.0-ptc.top_margin)/
				   (max_gene+1.0)); // %%%

	  rootGT.r_local_fixed_recalc(0,(float)(Math.PI*2),ptc);
	}
      }
      else { // weighted

	if (rootGT.ds==0) {
	  rootGT.leaf_calc();
	}

	if (disp_mode=='t') {
	  rootGT.step=(float)((cvw_height-ptc.top_margin-ptc.bot_margin)/
			      (max_gene+2.0));   // ###

	  rootGT.weighted_offdraw(ptc.sid_margin,rootGT.ds,
				  cvw_width-ptc.sid_margin*2,
				  cvw_width-ptc.sid_margin*2,ptc);
	}
	else if (disp_mode=='r') {
	  if (cvw_height<cvw_width) 
	    rootGT.step=(float)((cvw_height/2.0-ptc.top_margin)/
				(max_gene+2.0));   // %%%
	  else rootGT.step=(float)((cvw_width/2.0-ptc.top_margin)/
				   (max_gene+2.0)); // %%%

	  rootGT.r_weighted_offdraw(0,rootGT.ds,
				    (float)(Math.PI*2),
				    (float)(Math.PI*2),ptc);
	}
	else if (disp_mode=='l') {
	  if (cvw_height<cvw_width) 
	    rootGT.step=(float)((cvw_height/2.0-ptc.top_margin)/
				(max_gene+2.0));   // %%%
	  else rootGT.step=(float)((cvw_width/2.0-ptc.top_margin)/
				   (max_gene+2.0)); // %%%

	  rootGT.r_local_weighted_offdraw(0,rootGT.ds,
					  (float)(Math.PI*2),
					  (float)(Math.PI*2),ptc);
	}
      }

      ptc.flush();

      dsp_button.setEnabled(true);
      dspMenu.setEnabled(true);
      treeMenu.setEnabled(true);
    }
  };
  // ###


  // ###
  void drawpt_susp() {
    //System.out.println("%%% drawpt_susp: run="+run+" sus="+sus);

    rootGT.redraw_flag=false;
    wsize_changed=false; // ###
      
    ptc.coordinate_offScr0(rootGT);

    dspMenu.setEnabled(false);
    treeMenu.setEnabled(false);

    ptc.drwc=0; // %%%

    if (disp_mode=='t') {
      rootGT.step=(float)((cvw_height-ptc.top_margin-ptc.bot_margin)/
			  (max_gene+1.0));   // ###
      
      rootGT.position_calc0(ptc.sid_margin,
			    cvw_width-ptc.sid_margin*2,
			    cvw_height,ptc,ptc.curGT);
    }
    else if (disp_mode=='r') {
      if (cvw_height<cvw_width) {
	rootGT.step=
	  (float)((cvw_height/2.0-ptc.top_margin)/
		  (max_gene+1.0));
	
	rootGT.radial_position_calc0(0,(float)Math.PI*2,
				     (int)(cvw_height/2.0),
				     ptc,ptc.curGT);
      }
      else {
	rootGT.step=
	  (float)((cvw_width/2.0-ptc.top_margin)/
		  (max_gene+1.0));
	
	rootGT.radial_position_calc0(0,(float)Math.PI*2,
				     (int)(cvw_width/2.0),
				     ptc,ptc.curGT);
      }
    }
    else if (disp_mode=='l') {
      if (cvw_height<cvw_width) {
	rootGT.step=
	  (float)((cvw_height/2.0-ptc.top_margin)/
		  (max_gene+1.0));
	
	rootGT.rad_local_position_calc0(0,(float)Math.PI*2,
					(int)(cvw_height/2.0),
					ptc,ptc.curGT);
      } 
      else {
	rootGT.step=
	  (float)((cvw_width/2.0-ptc.top_margin)/
		  (max_gene+1.0));
	
	rootGT.rad_local_position_calc0(0,(float)Math.PI*2,
					(int)(cvw_width/2.0),
					ptc,ptc.curGT);
      }
      
    }

    ptc.flush();

    dspMenu.setEnabled(true);
    treeMenu.setEnabled(true);

  }

  public Thread create_DispT() {
    return new DispT();
  }
  public Thread create_DrawPT() {
    return new DrawPT();
  }


  class DispT extends Thread {
    DispT() {}
    public void run(){
      dsp_button_Clicked();
      dspt=null;
      //System.out.println("DispT stopped");
      stop();
    }
  }


  class DrawPT extends Thread {
    DrawPT() {}
    public void run(){
      drawpt_susp();
      drwpt=null;
      //System.out.println("DrawPT stopped");
      stop();
    }
  }



  void readf_button_Clicked() {
    default_textF_color(readf_txt);
    //
    readf_txt_flag=true; // %%% essential
    //
    readf_txt.setText("open file");
    FileDialog fd=new FileDialog(this, "Open");
    dir1=fd.getDirectory();
    //System.out.println("setDir: "+dir1);
    fd.setDirectory(dir1);
    fd.setFilenameFilter(new MGFileFilter());
    //fd.show();
    fd.setVisible(true);
    if (fd.getFile()!=null) {
      fil1=fd.getFile();
      dir1=fd.getDirectory();
      //System.out.println("My Dir ="+dir1);
    }
    String filename=dir1+fil1;
    //System.out.println("My filename ="+filename);
    //
    readf_txt_flag=true; // %%% essential
    //
    readf_txt.setText(fil1);
    File f=new File(dir1,readf_txt.getText());
    //System.out.println("textValChanged run = "+run+
    //		 " f.isFile() = "+f.isFile()+
    //		 " f.canRead() = "+f.canRead());
    boolean b=f.isFile() && f.canRead();  
    if (b) {
      default_textF_color(readf_txt);
      run_button.setEnabled(!run);
    }  
    else {
      readf_txt.setForeground(Color.red);
      run_button.setEnabled(false);
    }

    //
  }

  void run_button_Clicked() {
    //System.out.println("run_button clicked: run="+run+" sus"+sus);
    //System.out.println("run_button clicked: run="+run+" sus"+sus+
    //	       " mgtp="+mgtp+" rootGT="+rootGT+
    //	       " ptc.curGT="+ptc.curGT);

    tree_mode=menu_tree_mode; // ###
    disp_mode=menu_disp_mode; // ###

    quit=false; // ###      
    ptc.ox1=ptc.lox1=0; // ###  for PTdrawLine and PTfillOval
    ptc.oy1=ptc.loy2=0; // ###  for PTdrawLine and PTfillOval

    // ### for GC
    rootGT=ptc.curGT=null; 
    ptc.offScr=null;
    ptc.og=null;
    ptc.gt=null;
    if (mgtp!=null) {
      //System.out.println("run: mgtp="+mgtp);
      mgtp.curGT=null;  // %%% essential!
      mgtp.pt_top=null; // %%% essential!
    }
    mgtp=null;
    System.gc();
    // ###

    if (sus) {
      //System.out.println("Stop Prove and ProveT");
      pt.pv.stop();
      pt.stop();
      sus=false;
      susp_button.setLabel("Suspend");
    }

    int i=1;
    
    o_verbose.setEnabled(false);
    o_allSol.setEnabled(false);
    o_selectMin.setEnabled(false);
    o_compileExt.setEnabled(false);
    
    if (o_verbose.getState()) i++;
    if (o_allSol.getState()) i++;
    if (o_selectMin.getState()) {i++;} 
    else {pickup='f';}

    if (o_compileExt.getState()) i++;
    if (ptc.execProve_mode && repnumS!="0") {i+=2;} 
    
    String[] args=new String[i];
    
    System.out.print("\nNow reading file: " + dir1 + fil1 + "...\n");
    args[0]=dir1+fil1;
    i=0;
    if (o_verbose.getState()) {i++;args[i]="verbose";}
    if (o_allSol.getState()) {i++;args[i]="all";}
    if (o_selectMin.getState()) {
      i++;
      args[i]="min";
      pickup='m';
    }
    if (o_compileExt.getState()) {i++;args[i]="ext";}
    if (ptc.execProve_mode && repnumS!="0") {
      i++;args[i]="repeat";
      i++;args[i]=repnumS;
    } 

    o_verbose.setEnabled(true);
    o_allSol.setEnabled(true);
    o_selectMin.setEnabled(true);
    o_compileExt.setEnabled(true);

    //System.out.println("new ProveT");

    pt=new ProveT(this,args);
    pt.setPriority(Thread.MIN_PRIORITY);
    //
    ptc.pt=pt; // %%%
    //
    pt.start();
  }

  void quit_button_Clicked() {
    //System.out.println("quit_button clicked: run="+run+" sus"+sus);
    if (run) {
      quit=true; // ###
      if (pt!=null) {
	//	if (pt.ptv!=null) pt.pv.stop();
	if (pt.ptv!=null) {
	  pt.pv.suspend();
	  //System.out.println("execution aborted");

	  exectime=System.currentTimeMillis()-mgtp.time;
	  if (stwindow!=null) {
	    if (ptc.execProve_mode) stwindow.displaystatusExec();
	    else stwindow.displaystatus();
	  }
	  pt.pv.stop();
	}
	pt.stop();
	pt=null;
      }

      susp_button.setEnabled(false);
      quit_button.setEnabled(false); // ###
      run_button.setEnabled(true);
      //ptv.readf_txt.setEnabled(true);
      readf_button.setEnabled(true);

      sus=false;
      susp_button.setLabel("Suspend");
      run=false;
    }
  }

  
  class CMDialog extends Dialog implements ActionListener,TextListener {
    Panel panel;
    TextField h_text,v_text;
    Label h_label,v_label;
    Button okButton,cancelButton;
    boolean h_n_flag=true,v_n_flag=true;
    float h,v;
    CMDialog(Frame f) {
      super(f,"Custom Multi Dialog",true);
      //      setLayout(new BorderLayout(10,10));
      h=ptc.cur_mult_h;
      v=ptc.cur_mult_v;
      GridBagLayout gbl=new GridBagLayout();
      panel=new Panel(gbl);
      GridBagConstraints c=new GridBagConstraints();
      c.ipady=5;
      c.ipadx=5;
      //      c.insets=10;
      c.fill=GridBagConstraints.HORIZONTAL;
      h_label=new Label(" mult H ",Label.CENTER);
      v_label=new Label(" mult V ",Label.CENTER);
      h_text=new TextField(Float.toString(h),8);
      v_text=new TextField(Float.toString(v),8);
      //
      default_textF_color(h_text); // ###
      default_textF_color(v_text); // ###
      //
      h_text.addTextListener(this);
      v_text.addTextListener(this);
      okButton=new Button("OK");
      cancelButton=new Button("Cancel");
      okButton.addActionListener(this);
      cancelButton.addActionListener(this);
      add(panel,"Center");

      c.gridx=0;c.gridy=0;
      gbl.setConstraints(h_label,c);
      panel.add(h_label);
      panel.add(h_text);
      panel.add(v_label);
      panel.add(v_text);
      c.gridx=2;c.gridy=1;
      gbl.setConstraints(okButton,c);            
      panel.add(okButton);
      c.gridx=3;c.gridy=1;
      gbl.setConstraints(cancelButton,c);
      panel.add(cancelButton);
      pack();
      //setResizable(false);
      addWindowListener(new cmdl());
    }
        
    class cmdl extends WindowAdapter {
      public void windowClosing(WindowEvent e) {
	zoomChoice.select(old_select_zoom);
	cur_select_zoom=old_select_zoom;
	dispose();                
      }
    }
        
    
    public void actionPerformed(ActionEvent e) {
      if(e.getSource()==okButton) {
	ptc.cur_mult_h=h;
	ptc.cur_mult_v=v;
	//
	zoom_h_val=h; // %%%
	zoom_v_val=v; // %%%
	//
	dispose();
      } else if (e.getSource()==cancelButton) {
	zoomChoice.select(old_select_zoom);
	cur_select_zoom=old_select_zoom;
	dispose();
      }
    }
  
    public void textValueChanged(TextEvent e) {
      if (e.getSource()==h_text) {
	try {
	  h=(Float.valueOf(h_text.getText())).floatValue();
	  h_n_flag=true;
	} catch(NumberFormatException nfe) {
	  h_n_flag=false;
	}
      } else if (e.getSource()==v_text) {
	try {
	  v=(Float.valueOf(v_text.getText())).floatValue();
	  v_n_flag=true;
	} catch(NumberFormatException nfe){
	  v_n_flag=false;
	}  
      }
      if (h_n_flag && v_n_flag) okButton.setEnabled(true);
      else okButton.setEnabled(false);
      
    }
  }

  //
  class ParamDialog extends Dialog implements ActionListener,TextListener {
    Panel panel;
    TextField stpa_text,sync_text,tmar_text,bmar_text,smar_text;
    Label stpa_label,sync_label,tmar_label,bmar_label,smar_label;
    Button okButton,cancelButton,defaultButton;
    float stpa;
    int sync,tmar,bmar,smar;

    ParamDialog(Frame f) {
      super(f,"Parameter Dialog",true);
      stpa=ptc.step_adjust;
      sync=ptc.sync_max;
      tmar=ptc.top_margin;
      bmar=ptc.bot_margin;
      smar=ptc.sid_margin;
      GridBagLayout gbl=new GridBagLayout();
      panel=new Panel(gbl);
      GridBagConstraints c=new GridBagConstraints();
      c.ipady=5;
      c.ipadx=5;
      //      c.insets=10;
      c.fill=GridBagConstraints.HORIZONTAL;
      stpa_label=new Label("Step Rate  ",Label.CENTER);
      sync_label=new Label("Sync Max   ",Label.CENTER);
      tmar_label=new Label("WTop Margin",Label.CENTER);
      bmar_label=new Label("WBot Margin",Label.CENTER);
      smar_label=new Label("WSid Margin",Label.CENTER);

      stpa_text=new TextField(Float.toString(stpa),8);
      sync_text=new TextField(Float.toString(sync),8);
      tmar_text=new TextField(Float.toString(tmar),8);
      bmar_text=new TextField(Float.toString(bmar),8);
      smar_text=new TextField(Float.toString(smar),8);

      default_textF_color(stpa_text); // ###
      default_textF_color(sync_text); // ###
      default_textF_color(tmar_text); // ###
      default_textF_color(bmar_text); // ###
      default_textF_color(smar_text); // ###

      stpa_text.addTextListener(this);
      sync_text.addTextListener(this);
      tmar_text.addTextListener(this);
      bmar_text.addTextListener(this);
      smar_text.addTextListener(this);

      okButton=new Button("OK");
      cancelButton=new Button("Cancel");
      defaultButton=new Button("Default");
      okButton.addActionListener(this);
      cancelButton.addActionListener(this);
      defaultButton.addActionListener(this);
      //
      add(panel,"Center");

      c.gridx=0;c.gridy=0;
      gbl.setConstraints(stpa_label,c);
      panel.add(stpa_label);
      c.gridx=1;c.gridy=0;
      gbl.setConstraints(stpa_text,c);
      panel.add(stpa_text);
      c.gridx=0;c.gridy=1;
      gbl.setConstraints(sync_label,c);
      panel.add(sync_label);
      c.gridx=1;c.gridy=1;
      gbl.setConstraints(sync_text,c);
      panel.add(sync_text);

      c.gridx=0;c.gridy=2;
      gbl.setConstraints(tmar_label,c);
      panel.add(tmar_label);
      c.gridx=1;c.gridy=2;
      gbl.setConstraints(tmar_text,c);
      panel.add(tmar_text);
      c.gridx=0;c.gridy=3;
      gbl.setConstraints(bmar_label,c);
      panel.add(bmar_label);
      c.gridx=1;c.gridy=3;
      gbl.setConstraints(bmar_text,c);
      panel.add(bmar_text);

      c.gridx=0;c.gridy=4;
      gbl.setConstraints(smar_label,c);
      panel.add(smar_label);
      c.gridx=1;c.gridy=4;
      gbl.setConstraints(smar_text,c);
      panel.add(smar_text);

      stpa_text.setText(Float.toString(ptc.step_adjust));
      sync_text.setText(Integer.toString(ptc.sync_max));
      tmar_text.setText(Integer.toString(ptc.top_margin));
      bmar_text.setText(Integer.toString(ptc.bot_margin));
      smar_text.setText(Integer.toString(ptc.sid_margin));

      c.gridx=0;c.gridy=5;
      gbl.setConstraints(defaultButton,c);            
      panel.add(defaultButton);
      c.gridx=1;c.gridy=5;
      gbl.setConstraints(okButton,c);            
      panel.add(okButton);
      c.gridx=2;c.gridy=5;
      gbl.setConstraints(cancelButton,c);
      panel.add(cancelButton);
      pack();
      //setResizable(false);
      //      addWindowListener(new paraml());
    }
        
    public void actionPerformed(ActionEvent e) {
      if(e.getSource()==okButton) {
	ptc.step_adjust=stpa;
	ptc.sync_max=sync;
	ptc.top_margin=tmar;
	ptc.bot_margin=bmar;
	ptc.sid_margin=smar;
	dispose();
      } else if (e.getSource()==defaultButton) {
	ptc.step_adjust=PTCanvas.step_adjust_default;
	ptc.sync_max=PTCanvas.sync_max_default;
	ptc.top_margin=PTCanvas.top_margin_default;
	ptc.bot_margin=PTCanvas.bot_margin_default;
	ptc.sid_margin=PTCanvas.sid_margin_default;
	stpa_text.setText(Float.toString(ptc.step_adjust));
	sync_text.setText(Integer.toString(ptc.sync_max));
	tmar_text.setText(Integer.toString(ptc.top_margin));
	bmar_text.setText(Integer.toString(ptc.bot_margin));
	smar_text.setText(Integer.toString(ptc.sid_margin));
      } else if (e.getSource()==cancelButton) {
	dispose();
      }
    }
  
    public void textValueChanged(TextEvent e) {
      boolean changed=false;
      if (e.getSource()==stpa_text) {
	try {
	  stpa=(Float.valueOf(stpa_text.getText())).floatValue();
	  changed=true;
	} catch(NumberFormatException nfe) {}
      } 
      else if (e.getSource()==sync_text) {
	try {
	  sync=(Integer.valueOf(sync_text.getText())).intValue();
	  changed=true;
	} catch(NumberFormatException nfe) {}  
      } 
      else if (e.getSource()==tmar_text) {
	try {
	  tmar=(Integer.valueOf(tmar_text.getText())).intValue();
	  changed=true;
	} catch(NumberFormatException nfe) {}  
      } 
      else if (e.getSource()==bmar_text) {
	try {
	  bmar=(Integer.valueOf(bmar_text.getText())).intValue();
	  changed=true;
	} catch(NumberFormatException nfe) {}  
      } 
      else if (e.getSource()==smar_text) {
	try {
	  smar=(Integer.valueOf(smar_text.getText())).intValue();
	  changed=true;
	} catch(NumberFormatException nfe) {}  
	
      } 
      if (changed) okButton.setEnabled(true);
      else okButton.setEnabled(false);
    }
  }
  //
    
  class PTWindowListener extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      dispose();
      System.exit(0);
    }
  }

  //

  
  
}


class MGFileFilter implements FilenameFilter {
  public boolean accept(File dir,String name) {
    return name.endsWith(".mg");
    //    return ".mg".endsWith(name);
  }
}


class PTCanvas extends Canvas 
//implements ItemListener,AdjustmentListener {
implements ItemListener,AdjustmentListener {
  int cvw_height; 	
  int cvw_width;
  Scrollbar h,v;
  float cur_mult_h=1;
  float cur_mult_v=1;
  float old_mult_h=1;
  float old_mult_v=1;
  int oval_r=4;
  int root_oval_r=5;
  float zoom_left_x=0;
  float zoom_top_y=0;
  //
  static float step_adjust_default=(float)0.8;
  //  static int sync_max_default=10;
  static int sync_max_default=200;
  static int top_margin_default=20;
  static int bot_margin_default=20;
  static int sid_margin_default=20;

  static int font_size_default=16;
  static String font_type_default="Courier";
  static Color node_color_default=Color.black;
  static Color line_color_default=Color.black;
  static boolean node_circ_default=true; // ###

  static float step_adjust;
  static int sync_max;
  static int top_margin;
  static int bot_margin;
  static int sid_margin;

  static int font_size;
  static String font_type;
  static Color node_color;
  static Color line_color;
  //
  static boolean node_circ; // ###
  static Font node_font;
  //
  static Exec exec;
  static boolean execProve_mode=false;
  //
  Image offScr;
  Graphics og;
  int od=oval_r*2;
  int rod=root_oval_r*2;
  GT gt;
  // %%%
  static GT curGT;
  static ProveT pt;
  static GTCount gtc;
  //
  PTVisualizer ptv;
  GTWindow gtw;
  GTWindow select_gtw;
  Cursor cursor;
  boolean zoom_select=false;
  int rect_width,rect_height;
  volatile boolean zoom_redraw=false;
  int mouse_x;
  int mouse_y;
  float scroll_value;
  //
  Thread zmt=null;
  Draw scrl; // ###
  // ###
  int ox1=0; 
  int lox1=0;
  int oy1=0; 
  int loy2=0;
  int[] ys;
  int[] lys;
  int[] xs;
  int[] lxs;
  //
  public int drwlim=200; // %%%
  public int drwc=0; // %%%

  PTCanvas() {}
  PTCanvas(int cvww,int cvwh,int lgww,int lgwh,PTVisualizer ptvz) {
    cvw_height=cvwh;
    cvw_width=cvww;
    ptv=ptvz;
    //
    step_adjust=step_adjust_default;
    sync_max=sync_max_default;
    top_margin=top_margin_default;
    bot_margin=bot_margin_default;
    sid_margin=sid_margin_default;
    font_size=font_size_default;
    font_type=font_type_default;
    node_color=node_color_default;
    line_color=line_color_default;
    node_circ=node_circ_default; // ###
    // ###
    ptv.chkbox_exclusive_setState(1,ptv.fonts,ptv.fontNames);
    ptv.chkbox_exclusive_setState(3,ptv.fsizes,ptv.fsizeNames);
    ptv.chkbox_exclusive_setState(0,ptv.ncolors,ptv.colorNames);
    ptv.chkbox_exclusive_setState(0,ptv.lcolors,ptv.colorNames);

    ptv.subnt_circ.setState(true);
    ptv.subnt_text.setState(false);
    // ###

    node_font=new Font(font_type,Font.PLAIN,font_size);
    setFont(node_font);
    // String str[]=Toolkit.getDefaultToolkit().getFontList();
    // for(int i=0;i<5;i++) {System.out.println(str[i]);}
    //
    addMouseListener(new PTMouseListener());
    addMouseMotionListener(new PTMouseMotionListener());
    cursor=new Cursor(Cursor.DEFAULT_CURSOR);

    addComponentListener(new PTComponentListener()); // ###

  }


  void zoomReset() {
    cur_mult_h=1;
    cur_mult_v=1;
    old_mult_h=1;
    old_mult_v=1;
    ptv.zoom_h_txt.setText(Float.toString(cur_mult_h));
    ptv.zoom_v_txt.setText(Float.toString(cur_mult_v));
    ptv.cur_select_zoom=ptv.old_select_zoom=0;
    ptv.zoomChoice.select(ptv.cur_select_zoom);
    zoom_left_x=0;
    zoom_top_y=0;
    //    h.setMaximum(cvw_width);
    h.setValues(0,cvw_width,0,cvw_width);
    //    v.setMaximum(cvw_height);
    v.setValues(0,cvw_height,0,cvw_height);        
  }
    
  void coordinate_offScr(GT g) {
    gt=g;
    //System.out.println("old offs+"+offScr+" old og="+og);
    offScr=createImage(cvw_width,cvw_height);
    og=offScr.getGraphics();
    //System.out.println("new offs+"+offScr+" new og="+og);
  }
  void coordinate_offScr0(GT g) {
    gt=g;
    ptcClear0(); // ### added to erase gohst at zoom-point clicking
    //System.out.println("old offs+"+offScr+" old og="+og);
    offScr=createImage(cvw_width,cvw_height); // %%% 2k.04.11
    og=offScr.getGraphics();
    //System.out.println("new offs+"+offScr+" new og="+og);
  }
  

  void drawNode0(GT g) {
    //    og.setColor(g.p_color);
    // ### pink: success leaf node, blue: failed leaf node
    // ### red: from node in GTW, yellow: to node in GTW
    if (g.p_color==Color.pink || g.p_color==Color.blue ||
	g.p_color==Color.red || g.p_color==Color.yellow)
      og.setColor(g.p_color);
    else og.setColor(node_color);
    if (g==gt) PTfillOval0(og,g.x,g.y,root_oval_r,rod,g);
    else PTfillOval0(og,g.x,g.y,oval_r,od,g);
    //    og.setColor(Color.black);
    og.setColor(node_color);
  }

  void drawNode(GT g) {
    //    og.setColor(g.p_color);
    // ### pink: success leaf node, blue: failed leaf node
    // ### red: from node in GTW, yellow: to node in GTW
    if (g.p_color==Color.pink || g.p_color==Color.blue ||
	g.p_color==Color.red || g.p_color==Color.yellow)
      og.setColor(g.p_color);
    else og.setColor(node_color);
    if (g==gt) PTfillOval(og,g.x,g.y,root_oval_r,rod,g);
    else PTfillOval(og,g.x,g.y,oval_r,od,g);
    //    og.setColor(Color.black);
    og.setColor(node_color);
  }

  // %%%
  void drawNode_count(GT g) {
    //    og.setColor(g.p_color);
    // ### pink: success leaf node, blue: failed leaf node
    // ### red: from node in GTW, yellow: to node in GTW
    if (g.p_color==Color.pink || g.p_color==Color.blue ||
	g.p_color==Color.red || g.p_color==Color.yellow)
      og.setColor(g.p_color);
    else og.setColor(node_color);
    if (g==gt) PTfillOval(og,g.x,g.y,root_oval_r,rod,g);
    else PTfillOval(og,g.x,g.y,oval_r,od,g);
    //    og.setColor(Color.black);
    og.setColor(node_color);
    drwc++;
    if (drwc>drwlim) {
      drwc=0;
      flush();
    }
  }
  // %%%
    
  void drawBranch(float fcx,float fcy,float w,int bros,float px,float py){
    int i;
    float x=fcx;
    for (i=0;i<bros;i++,x=x+w) {
      PTdrawLine(og,px,py,x,fcy);
    }
  }
    
  void rad_drawBranch(float fcx,float fcy,float r,float f,float w,
		      int bros,float px,float py){
    PTdrawLine(og,px,py,fcx,fcy);
    if (bros>1) {
      float t=f+w;
      float x;
      float y;
      for (int i=1;i<bros;i++,t=t+w) {
	y=(float)(r*Math.sin(t)+cvw_height/2.0);
	x=(float)(r*Math.cos(t)+cvw_width/2.0);
	PTdrawLine(og,px,py,x,y);
      }
    }
  }
    
  void rad_local_drawBranch(float fcx,float fcy,float s,float f,float w,
			    int bros,float px,float py){
    PTdrawLine(og,px,py,fcx,fcy);
    if (bros>1) {
      float t=f+w;
      float x;
      float y;
      for(int i=1;i<bros;i++,t=t+w){
	y=py+(float)(s*Math.sin(t));
	x=px+(float)(s*Math.cos(t));
	PTdrawLine(og,px,py,x,y);
      }
    }
  }
    
  void flush() {
    paint(getGraphics());
  }
  
  void ptcClear() {
    if (offScr!=null) flush();
    else getGraphics().clearRect(0,0,cvw_width,cvw_height);
  }
  // ### added to erase gohst at zoom-point clicking
  void ptcClear0() {
    getGraphics().clearRect(0,0,cvw_width,cvw_height);
  }


  void PTdrawLine(Graphics g,float x,float y,float to_x,float to_y) {
    int x1=(int)((x-zoom_left_x)*old_mult_h+0.5);
    int y1=(int)((y-zoom_top_y)*old_mult_v+0.5);
    int x2=(int)((to_x-zoom_left_x)*old_mult_h+0.5);
    int y2=(int)((to_y-zoom_top_y)*old_mult_v+0.5);
    //System.out.println("x1="+x1+" y1="+y1+"x2="+x2+" y2="+y2);

    // ### check if already done (for tree)
    //    if (ptv.disp_mode=='t' && (y1>=0) && y1<cvw_height) {
    if (ptv.disp_mode=='t' && (y1>=0) && y1<cvw_height && gt.W<1) {
      if (lox1!=x1) {
	lys=new int[cvw_height];
	lox1=x1; lys[y1]=x2+y2;
      } else if (lys[y1]==(x2+y2)) {
	//System.out.println("x1="+x1+" y1="+y1+"x2="+x2+" y2="+y2);
	return;
      } else lys[y1]=x2+y2;
    }

    if (((x1>=0)&&(x1<=cvw_width)&&(y1>=0)&&(y1<=cvw_height))||
	((x2>=0)&&(x2<=cvw_width)&&(y2>=0)&&(y2<=cvw_height))) {

      g.setColor(line_color);
      g.drawLine(x1,y1,x2,y2);
    }
  }


  void PTfillOval0(Graphics g,float x,float y,int r,int d,GT gt) {
    if (!node_circ) {r=r-1; d=d-2;}
    int x1=(int)((x-zoom_left_x)*old_mult_h-r+0.5);
    int y1=(int)((y-zoom_top_y)*old_mult_v-r+0.5);
    if ((x1+d>=0)&&(x1<=cvw_width)&&(y1+d>=0)&&(y1<=cvw_height)) {
      g.fillOval(x1,y1,d,d);
      if (!node_circ) {
	//	g.drawString(lit,x1,y1);
	g.drawString(gt.toStr(),x1+2,y1-2);
      }
    }
  }	


  void PTfillOval(Graphics g,float x,float y,int r,int d,GT gt) {
    if (!node_circ) {r=r-1; d=d-2;}
    int x1=(int)((x-zoom_left_x)*old_mult_h-r+0.5);
    int y1=(int)((y-zoom_top_y)*old_mult_v-r+0.5);
    //System.out.println("x1="+x1+" y1="+y1);

    // ### check if already done (for tree)
    //    if (ptv.disp_mode=='t' && (y1>=0) && y1<cvw_height) {
    if (ptv.disp_mode=='t' && (y1>=0) && y1<cvw_height && gt.W<1) {
      if (ox1!=x1) {
	ys=new int[cvw_height];
	ox1=x1; ys[y1]=y1;
      } else if (ys[y1]==y1 && gt.p_color==Color.black) {
	//System.out.println("x1="+x1+" y1="+y1);
	//acount++; 
	//System.out.println("acount="+acount+" x1="+x1+" y1="+y1+
	//	   " gt.W="+gt.W);
	return;
      }
      else ys[y1]=y1;
    }

    if ((x1+d>=0)&&(x1<=cvw_width)&&(y1+d>=0)&&(y1<=cvw_height)) {
      g.fillOval(x1,y1,d,d);
      if (!node_circ) {
	//	g.drawString(lit,x1,y1);
	g.drawString(gt.toStr(),x1+2,y1-2);
      }
    }
  }	


  void PTdrawRect(Graphics g,int x,int y,int width,int height) {
    g.setColor(Color.lightGray);
    g.drawRect(x,y,width,height);
    g.setColor(Color.black);
  }
    
  public void paint(Graphics g) {
    if (offScr!=null) {
      g.drawImage(offScr,0,0,this);
    }
  }
    
  public void itemStateChanged(ItemEvent e) {
    GTWindow gtw_w=gtw;
    char w=ptv.cursor_state;
    while (gtw_w!=null) {
      if (w=='n') 
	gtw_w.setCursor(cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
      else if (w=='s') 
	gtw_w.setCursor(cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      if (e.getSource()==gtw_w.tn_button) {
	if (gtw_w.tn_button.getState()) {
	  ptv.setCursor(cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	  ptv.cursor_state='s';
	  select_gtw=gtw_w;
	} else {
	  ptv.setCursor(cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	  ptv.cursor_state='n';
	  select_gtw=null;
	}
      } else{
	if (w=='n') gtw_w.tn_button.setEnabled(false);
	else if (w=='s') gtw_w.tn_button.setEnabled(true);
      }
      gtw_w=gtw_w.prev;
    }
  }
    
  void s_To_n() {
    GTWindow gtw_w=gtw;
    while (gtw_w!=null) {
      gtw_w.setCursor(cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      gtw_w.tn_button.setEnabled(true); 
      gtw_w=gtw_w.prev; 
    }
    ptv.setCursor(cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    ptv.cursor_state='n';
    select_gtw=null;
  }
  
  void ZoomRedraw() {
    //System.out.println("ZoomRedraw invoked: mouse_x="+
    //	       mouse_x+" mouse_y="+mouse_y);
    if (mouse_x>=0 && mouse_y>=0) {
      zoom_left_x=zoom_left_x+mouse_x/old_mult_h-cvw_width/cur_mult_h/2;
      zoom_top_y=zoom_top_y+mouse_y/old_mult_v-cvw_height/cur_mult_v/2;
      old_mult_h=cur_mult_h;
      old_mult_v=cur_mult_v;
      h.setMaximum((int)(cur_mult_h*cvw_width));
      h.setValue((int)(zoom_left_x*cur_mult_h));
      v.setMaximum((int)(cur_mult_v*cvw_height));
      v.setValue((int)(zoom_top_y*cur_mult_v));
    } 
    else if (mouse_x==0) zoom_left_x=scroll_value;
    else if(mouse_y==0) zoom_top_y=scroll_value;
    coordinate_offScr(gt); 
    gt.zoom_Redraw(PTCanvas.this,curGT); // %%%
    flush();
    ptv.zoom_button.setEnabled(true); // ###
    ptv.old_select_zoom=ptv.cur_select_zoom;
  }
  
  class PTMouseListener extends MouseAdapter {
    public void mouseClicked(MouseEvent e) {
      Graphics og1; Image offScr1;
      GT select_gt;
      int mx=e.getX();
      int my=e.getY();

      if (zoom_select) {
	//System.out.println("mouseClicked under zoom_select"+
	//	   " mx="+mx+" my="+my);
	zoom_select=false; 
	ptv.reset_button.setLabel("Reset");
	setCursor(cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

	if (ptv.run==false && ptv.mgtp!=null) { 
	  // ***  zoom when not run or suspended ***
	  zoom_left_x=zoom_left_x+mx/old_mult_h-cvw_width/cur_mult_h/2;
	  zoom_top_y=zoom_top_y+my/old_mult_v-cvw_height/cur_mult_v/2;
	  old_mult_h=cur_mult_h; 
	  old_mult_v=cur_mult_v; 
	  h.setMaximum((int)(cur_mult_h*cvw_width));
	  h.setValue((int)(zoom_left_x*cur_mult_h));
	  v.setMaximum((int)(cur_mult_v*cvw_height));
	  v.setValue((int)(zoom_top_y*cur_mult_v));

	  coordinate_offScr(gt); 
	  if (ptv.sus) gt.zoom_Redraw(PTCanvas.this,curGT);
	  else gt.zoom_Redraw(PTCanvas.this);
	  flush();

	  ptv.zoom_button.setEnabled(true); // ###
	  //System.out.println("zoom_Redraw finished");
	  ptv.old_select_zoom=ptv.cur_select_zoom;
	}
	else if (ptv.run==true) {
	  // *** zoom while running ***
	  zoom_redraw=true;
	  mouse_x=mx;
	  mouse_y=my;

	  //System.out.println("zoom: suspend exec gt="+gt.toStr()+
	  //	     " curGT="+curGT.toStr());

	  pt.gtc.sus(); // suspend the execution
	  ZoomRedraw();
	  ptv.pt.gtc.resu(); // resume the execution
	  ptv.pt.gtc.ntfy();

	}
      } else {
	if (gt!=null) {
	  select_gt=gt.find(zoom_left_x+mx/cur_mult_h,zoom_top_y+my/cur_mult_v,
			    5/cur_mult_h,5/cur_mult_v);
	  if (select_gt!=null) {
	    if (ptv.cursor_state=='n') {
	      if (select_gt.p_color==Color.red) {
		GTWindow wgtw=gtw;
		while (wgtw!=null) {
		  //if (wgtw.cur_gt==select_gt) {wgtw.show();break;}
		  if (wgtw.cur_gt==select_gt) {wgtw.setVisible(true);break;}
		  wgtw=wgtw.prev;
		}
	      } 
	      else gtw=new GTWindow(select_gt,gt,PTCanvas.this,ptv,gtw);
	    } 
	    else if (ptv.cursor_state=='s') {
	      select_gtw.set_to_gt(select_gt);
	      s_To_n();
	      //	      drawNode(select_gt);
	      drawNode0(select_gt); // ###
	      flush();
	    }
	  }
	}
      }
    }
    
    public void mouseExited(MouseEvent e) {
      if(zoom_select) ptcClear(); 
      flush(); // ### helpful for earasing a gohst image of cursor
    }
    
    public void mouseEntered(MouseEvent e) {
      //System.out.println("mouseEntered under zoom_select");
      if (zoom_select) {
	PTdrawRect(getGraphics(),e.getX()-rect_width/2,e.getY()-rect_height/2,
		   rect_width,rect_height);
      }
    }
  }
  
  class PTMouseMotionListener extends MouseMotionAdapter {
    public void mouseMoved(MouseEvent e) {
      if (zoom_select) {
	ptcClear();
	PTdrawRect(getGraphics(),e.getX()-rect_width/2,e.getY()-rect_height/2,
		   rect_width,rect_height);
      }
    }

  }

  // ###
  class PTComponentListener extends ComponentAdapter {
    public void componentResized(ComponentEvent e) {
      //System.out.println("Component resized");
      ptv.wsize_changed=true;
      ptv.adjustCanvasWindowSize(); // ###

      if (ptv.run) {
	//System.out.println("Component resized in run mode");
	pt.gtc.sus(); 

	//	ptv.drawpt_susp(); // %%%

	ptv.resized_while_run=true; // %%%
	ptv.pt.gtc.resu();
	ptv.pt.gtc.ntfy();
      }
      else if (ptv.sus) {
	//System.out.println("Component resized in sus mode");
	if (ptv.drwpt!=null) {
	  ptv.drwpt.stop();
	  //System.out.println("drwpt stopped");
	  coordinate_offScr0(ptv.rootGT);
	  flush();
	}
	ptv.drwpt = ptv.create_DrawPT();
	ptv.drwpt.start();
      }
      else {
	if (ptv.dspt!=null) {
	  ptv.dspt.stop();
	  //System.out.println("dspt stopped");
	  coordinate_offScr0(ptv.rootGT);
	  flush();
	}
	ptv.dspt = ptv.create_DispT();
	ptv.dspt.start();
      }
    }

  }
  // ###

  public void adjustmentValueChanged(AdjustmentEvent e) {
    // ### event habdling for scroll bar 
    float work;
    if (e.getSource()==h) {
      work=h.getValue()/old_mult_h;
    if (zoom_left_x!=work) {
	zoom_left_x=work;
	if (ptv.run==false && ptv.mgtp!=null) {
	  //System.out.println("zoom_Redraw issued h");
	  ptv.zoom_button.setLabel("Scroll");
	  ptv.zoom_button.setEnabled(false);
	  if (zmt!=null) {
	    zmt.stop();
	    zmt=null;
	    //System.out.println("zmt stopped");
	  }
	  // ### should start after new creation
	  zmt=new ZoomT();
	  scrl = new Draw();  // ###
	  zmt.start();
	  scrl.execDraw();    // ###

	  zmt.stop(); // ###
          zmt=null;   // ###
          scrl=null;  // ###

	  ptv.zoom_button.setLabel("Zoom");
	  ptv.zoom_button.setEnabled(true);
	  //	  flush();
	} 
	else if(ptv.run==true) {
	  zoom_redraw=true;
	  mouse_x=0;
	  mouse_y=-1;
	  scroll_value=work;
	}
      }
      //System.out.println(zoom_left_x);
    } 
    else if (e.getSource()==v) {
      work=v.getValue()/old_mult_v;
      if (zoom_top_y!=work) {
	zoom_top_y=work;
	if (ptv.run==false && ptv.mgtp!=null) {
	  //System.out.println("zoom_Redraw issued v");
	  ptv.zoom_button.setLabel("Scroll");
	  ptv.zoom_button.setEnabled(false);
	  if (zmt!=null) {
	    zoomT_end();
	    //System.out.println("zmt stopped");
	  }
	  // ### should start after new creation
	  zmt=new ZoomT();
	  scrl = new Draw();  // ###
	  zmt.start();
	  scrl.execDraw();    // ###

	  zoomT_end(); // ###

	  ptv.zoom_button.setLabel("Zoom");
	  ptv.zoom_button.setEnabled(true);
	  //	  flush();
	} 
	else if (ptv.run==true) {
	  zoom_redraw=true;
	  mouse_x=-1;
	  mouse_y=0;
	  scroll_value=work;
	}
      }
      //System.out.println(zoom_top_y);
    }

  }
  
  void zoomT_end() {
    zmt.stop(); 
    zmt=null;   
    scrl=null;  
  }

  class ZoomT extends Thread {
    ZoomT() {}

    public void run(){
      //System.out.println("ZoomT");
    
      coordinate_offScr(gt);
      if (ptv.sus) gt.zoom_Redraw(PTCanvas.this,curGT); // %%%
      else {
	//System.out.println("zoom_Redraw(this)");
	gt.zoom_Redraw(PTCanvas.this);
      }
      flush();
      scrl.doneDraw();
      //System.out.println("ZoomT end");
    }
  }

}

class GTWindow extends Frame implements ActionListener {
  GT cur_gt;
  GT root_gt;
  GT to_gt;
  //  CheckboxGroup cg;
  Checkbox tn_button;
  Button dpr_button;
  Button dpt_button;
  Button rev_button;
  TextArea text1;
  TextArea text2;	
  TextArea text3;	
  Label label1;
  PTCanvas ptc;
  PTVisualizer ptv;
  String str_cur_gt,str_to_gt,str_disp="",str_rev="";
  boolean dpr_done=false;
  GTWindow next;
  GTWindow prev;
  GTWMouseListener GTWML;
    
  GTWindow(GT gt,GT rgt,PTCanvas pc,PTVisualizer ptvis,GTWindow prev_gtw) {
    super("Node Display Window : "+gt.toStr());
    //
    ptc=pc;
    ptv=ptvis;
    prev=prev_gtw;
    if (prev!=null) prev.next=this;

    cur_gt=gt;
    root_gt=rgt;
    cur_gt.old_color=cur_gt.p_color;
    cur_gt.p_color=Color.red;
    ptc.drawNode0(cur_gt); // ###
    addWindowListener(new GTWindowListener());
    GTWML=new GTWMouseListener();

    setup();
    setSize(290,418);
    setVisible(true);
    ptc.flush(); // ### should be done after setVisble(true)

    // ###
    if(ptv.rootGT.ds==0) {
      ptv.rootGT.leaf_calc(); 
    }
    str_cur_gt=cur_gt.unparseS_txtF(0);
    text1.setText(str_cur_gt);
    setVisible(true);
    // ###
  }
  
  void setup() {
    //
    setBackground(Color.lightGray);
    setForeground(Color.black);
    //
    Panel mainPanel=new Panel();
    Panel panels[]=new Panel[3];
    for (int i=0;i<3;++i) {
      panels[i]=new Panel();
    }
    //System.out.println("PANEL SETUPPED.");
    GridBagLayout gl;
    panels[0].setLayout(gl=new GridBagLayout());
    GridBagConstraints c=new GridBagConstraints();
    c.anchor=GridBagConstraints.NORTH;
    c.insets=new Insets(5,0,5,0);
    //    c.fill=GridBagConstraints.HORIZONTAL;
    label1=new Label("cur  node",Label.RIGHT);
    text1=new TextArea("",1,20,TextArea.SCROLLBARS_HORIZONTAL_ONLY);
    text1.setForeground(Color.black);
    text1.setBackground(new Color(230,230,240));
    //
    c.gridx=c.gridy=0;
    gl.setConstraints(label1,c);
    panels[0].add(label1);
    c.gridx=1;
    gl.setConstraints(text1,c);
    panels[0].add(text1);
    text1.setEditable(false);
    //    cg=new CheckboxGroup();
    //    tn_button=new Checkbox("select  node");
    tn_button=new Checkbox("to node");
    //    
    text2=new TextArea("",1,20,TextArea.SCROLLBARS_HORIZONTAL_ONLY);
    text2.setForeground(Color.black);
    text2.setBackground(new Color(230,230,240));
    //    text2.setBackground(Color.white);
    //
    c.gridy=1;
    c.gridx=0;
    gl.setConstraints(tn_button,c);
    tn_button.addItemListener(ptc);
    panels[0].add(tn_button);
    c.gridx=1;
    gl.setConstraints(text2,c);
    panels[0].add(text2);
    text2.setEditable(false);
    dpr_button=new Button("disp root");
    dpt_button=new Button(" disp  to  ");
    rev_button=new Button("   rev  ");
    dpr_button.addActionListener(this);
    dpt_button.addActionListener(this);
    rev_button.addActionListener(this);
    panels[1].add(dpr_button);
    panels[1].add(dpt_button);
    panels[1].add(rev_button);
    panels[2].add(text3=new TextArea(10,30));
    //
    text3.setForeground(Color.black);
    text3.setBackground(new Color(230,230,240));
    //
    for (int i=0;i<3;++i) {
      panels[i].addMouseListener(GTWML);
      mainPanel.add(panels[i]);
      add("Center",mainPanel);
    }
    mainPanel.addMouseListener(GTWML);
    label1.addMouseListener(GTWML);
  }

  
  void set_to_gt(GT tgt) {
    if(to_gt!=null) if (to_gt.p_color!=Color.red) {
      to_gt.p_color=to_gt.old_color;
      ptc.drawNode0(to_gt); // ###
    }
    to_gt=tgt;
    str_to_gt=to_gt.unparseS_txtF(0);
    text2.setText(str_to_gt);
    if (to_gt.p_color!=Color.red) {
      to_gt.old_color=to_gt.p_color;
      to_gt.p_color=Color.yellow;
    }
    tn_button.setState(false);
    //show();
    setVisible(true);
    ptc.flush(); // ###
  }
    
  public void actionPerformed(ActionEvent e) {
    if (e.getSource()==dpr_button) {
      str_disp="";
      str_rev="";
      GT wgt=cur_gt;            
      while (true) {
	str_rev=wgt.unparseS_txtF(0)+"\n"+str_rev;
	str_disp=str_disp+wgt.unparseS_txtF(0)+"\n";
	if(wgt.par==null) break;
	wgt=wgt.par;
      }
      text3.setText(str_disp);
      dpr_done=true;
    } 
    else if (e.getSource()==rev_button) {
      if (dpr_done) {text3.setText(str_rev); dpr_done=false;}
      else {text3.setText(str_disp); dpr_done=true;}
    } 
    else if (e.getSource()==dpt_button && to_gt!=null) {
      str_disp="";
      str_rev="";
      GT wgt; 
      if (cur_gt.gene>=to_gt.gene) {
	wgt=cur_gt;
	while (true) {
	  str_rev=wgt.unparseS_txtF(0)+"\n"+str_rev;
	  str_disp=str_disp+wgt.unparseS_txtF(0)+"\n";
	  if (wgt==to_gt) break;
	  if (wgt.par==null){
	    str_disp="Not on the current branch!";
	    str_rev="Not on the current branch!";
	    break;
	  }
	  wgt=wgt.par;
	}
      } 
      else {
	wgt=to_gt;
	while(true) {
	  str_disp=wgt.unparseS_txtF(0)+"\n"+str_disp;
	  str_rev=str_rev+wgt.unparseS_txtF(0)+"\n";
	  if (wgt==cur_gt) break;
	  if(wgt.par==null) {
	    if (cur_gt==root_gt) {
	      str_disp=root_gt.unparseS_txtF(0)+"\n"+str_disp;
	      str_rev=str_rev+root_gt.unparseS_txtF(0)+"\n"; 
	    } else {
	      str_disp="";
	      str_rev="";
              str_disp="Not on the current branch!";
	      str_rev="Not on the current branch!";
	    }
	    break;
	  }
	  wgt=wgt.par;
	}
      }
      text3.setText(str_disp);
      dpr_done=true;
    }
  }
    
  class GTWindowListener extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      cur_gt.p_color=cur_gt.old_color;
      ptc.drawNode0(cur_gt);    // ###
      if (to_gt!=null)
	if(to_gt.p_color==Color.yellow) {
	  to_gt.p_color=to_gt.old_color;
	  ptc.drawNode0(to_gt); // ###
	}
      ptc.flush();
      if (prev!=null) prev.next=next;
      if (next!=null) next.prev=prev;
      if (ptc.select_gtw==GTWindow.this) {
	ptc.select_gtw=null;
	GTWindow wgtw=ptc.gtw;
	ptv.setCursor(ptc.cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	ptv.cursor_state='n';
	while (wgtw!=null) {
	  wgtw.tn_button.setEnabled(true);
	  wgtw.setCursor(ptc.cursor.
			 getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	  wgtw=wgtw.prev;
	}
      }
      dispose();
    }
    
  }

  class GTWMouseListener extends MouseAdapter {
    public void mouseClicked(MouseEvent e) {
      //System.out.println("clicked");
      if (ptv.cursor_state=='s') {
	//System.out.println("s");
	ptc.select_gtw.set_to_gt(cur_gt);
	ptc.s_To_n();
	//	ptc.drawNode(cur_gt);
	ptc.drawNode0(cur_gt); // ###
	ptc.flush();
      }
    }
  }
  
}

class DispModeException extends Exception {
  GT gt;
  DispModeException(GT cur){super("change Display mode.");gt=cur;}
}



class STWindow extends Frame implements TextListener{
  MGTP0 mgtp;
  PTCanvas ptc;
  PTVisualizer ptv;
  
  Label label1,label2,label3,label4,label5,label6,label7,label8;
  TextField text1,text2,text4,text5,text6,text7,text8;
  TextArea text3;
  
  STWindow(MGTP0 mg, PTVisualizer ptvis, PTCanvas ptcv) {
    super();
    mgtp=mg;
    //
    ptv=ptvis;
    ptc=ptcv;
    //
    Date d=new Date();
    DateFormat df=
      DateFormat.getTimeInstance(DateFormat.DEFAULT,Locale.JAPANESE);
    setTitle("Status: "+df.format(d));
    setup();
    addWindowListener(new STWindowListener());
    if (ptc.execProve_mode) displaystatusExec(); // ###
    else displaystatus();

    pack();
    //       setSize(400,500);
    setSize(220,325);
    //    setResizable(false);
    //show();
    setVisible(true);
  }
  
  void setup() {
    GridBagLayout gl;
    //
    setBackground(Color.lightGray);
    setForeground(Color.black);
    //
    Panel mainPanel=new Panel(new FlowLayout());
    mainPanel.setLayout(gl=new GridBagLayout());
    GridBagConstraints c=new GridBagConstraints();
    c.anchor=GridBagConstraints.WEST;
    //c.insets=new Insets(5,0,5,0);
    label1=new Label("Max Depth");
    label2=new Label("Cur Depth");
    label3=new Label("Cur Atom",Label.CENTER);
    label4=new Label("Failed Br");
    label5=new Label("Success Br");
    label6=new Label("Atoms");
    label7=new Label("Exec Time");
    label8=new Label("Repeat Num");

    text1=new TextField(9);
    text2=new TextField(9);
    //    text3=new TextField(9);
    text3=new TextArea("",1,20,TextArea.SCROLLBARS_HORIZONTAL_ONLY);
    text4=new TextField(9);
    text5=new TextField(9);
    text6=new TextField(9);
    text7=new TextField(9);
    text8=new TextField(9);
    //
    text1.addTextListener(ptv);
    text2.addTextListener(ptv);
    text3.addTextListener(ptv);
    text4.addTextListener(ptv);
    text5.addTextListener(ptv);
    text6.addTextListener(ptv);
    text7.addTextListener(ptv);
    text8.addTextListener(ptv);
    ptv.default_textF_color(text1);
    ptv.default_textF_color(text2);
    ptv.default_textA_color(text3);
    ptv.default_textF_color(text4);
    ptv.default_textF_color(text5);
    ptv.default_textF_color(text6);
    ptv.default_textF_color(text7);
    ptv.default_textF_color(text8);
    //
    c.gridx=0;c.gridy=0;
    gl.setConstraints(label2,c);
    mainPanel.add(label2);
    c.gridx=1;c.gridy=0;
    gl.setConstraints(text2,c);
    mainPanel.add(text2);

    c.gridx=0;c.gridy=1;
    gl.setConstraints(label1,c);
    mainPanel.add(label1);
    c.gridx=1;c.gridy=1;
    gl.setConstraints(text1,c);
    mainPanel.add(text1);
      
    c.gridx=0;c.gridy=2;
    gl.setConstraints(label5,c);
    mainPanel.add(label5);
    c.gridx=1;c.gridy=2;
    gl.setConstraints(text5,c);
    mainPanel.add(text5);

    c.gridx=0;c.gridy=3;
    gl.setConstraints(label4,c);
    mainPanel.add(label4);
    c.gridx=1;c.gridy=3;
    gl.setConstraints(text4,c);
    mainPanel.add(text4);

    c.gridx=0;c.gridy=4;
    gl.setConstraints(label6,c);
    mainPanel.add(label6);
    c.gridx=1;c.gridy=4;
    gl.setConstraints(text6,c);
    mainPanel.add(text6);
    // %%%
    c.gridx=0;c.gridy=5;
    gl.setConstraints(label7,c);
    mainPanel.add(label7);
    c.gridx=1;c.gridy=5;
    gl.setConstraints(text7,c);
    mainPanel.add(text7);
    // ###
    c.gridx=0;c.gridy=6;
    gl.setConstraints(label8,c);
    mainPanel.add(label8);
    c.gridx=1;c.gridy=6;
    gl.setConstraints(text8,c);
    mainPanel.add(text8);
    
    c.gridx=0;c.gridy=7;
    c.gridwidth=2;
    c.fill=GridBagConstraints.HORIZONTAL;
    gl.setConstraints(label3,c);       
    mainPanel.add(label3);

    c.gridx=0;c.gridy=8;
    c.gridwidth=2;
    c.fill=GridBagConstraints.HORIZONTAL;
    gl.setConstraints(text3,c);
    mainPanel.add(text3);       
    
    add("Center",mainPanel);
  }
  
  void displaystatus() {
    long time;
    //System.out.println("displaystatus invoked");
    try {
      if (ptv.run || ptv.sus) {
	time=System.currentTimeMillis()-ptv.mgtp.time;
	//System.out.println("run="+ptv.run+" sus="+ptv.sus+" time0="+time);
	text7.setText(Long.toString(time));
      } else if (ptv.quit) {
	text7.setText(Long.toString(ptv.exectime));
      } else {
	//System.out.println("run="+ptv.run+" sus="+ptv.sus+
	//		     " time1="+ptv.mgtp.time);
	text7.setText(Long.toString(ptv.mgtp.time));
      }
      if (!ptv.ptc.execProve_mode) {
	text1.setEnabled(true);
	text2.setEnabled(true);
	text3.setEnabled(true);
      }
      //	text1.setText(Integer.toString(GT.max_gene));
      text1.setText(Integer.toString(ptv.max_gene));
      text2.setText(Integer.toString(ptc.curGT.gene));
      text3.setText(""+ptc.curGT.unparseS_txtF(0));
      text4.setText(Integer.toString(ptv.mgtp.failedBranches));
      text5.setText(Integer.toString(ptv.mgtp.models));
      text6.setText(Integer.toString(ptv.mgtp.atoms));
      //text7.setText(Long.toString(ptv.mgtp.time));
      text8.setText(ptv.repnumS);
      //
    } catch(NullPointerException e) {
      //System.out.println("null pointer exception in displaystatus()");
    }
  }
  void displaystatusExec() {
    String s1="         ";
    String s2="                    ";
    long time;
    //System.out.println("displaystatusExec invoked");
    try {
      text1.setEnabled(true);
      text2.setEnabled(true);
      text3.setEnabled(true);
      text1.setText(s1);
      text2.setText(s1);
      text3.setText(s2);
      text1.setEnabled(false);
      text2.setEnabled(false);
      text3.setEnabled(false);
      text4.setText(Integer.toString(ptv.mgtp.failedBranches));
      text5.setText(Integer.toString(ptv.mgtp.models));
      text6.setText(Integer.toString(ptv.mgtp.atoms));
      if (ptv.quit) {
	text7.setText(Long.toString(ptv.exectime));
      }
      else {
	text7.setText(Long.toString(ptv.mgtp.time));
      }
      text8.setText(ptv.repnumS);
      //
    } catch(NullPointerException e) {
      //System.out.println("null pointer exception in displaystatusExec()");
    }
  }

  String rAdjust(String str,int cls) {
    int bn=cls-str.length();
    //System.out.println("blank num="+bn);
    String s="";
    while (bn!=0) {
      //      s=s+"  ";
      s=s+" ";
      bn--;
    }
    return  s+str;
  }
  

  public void textValueChanged(TextEvent e) {}
  
  class STWindowListener extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      dispose();
    }
  }
  
}

// eof


