/* This file was generated by SableCC (http://www.sable.mcgill.ca/sablecc/). */

package tudresden.ocl.parser.lexer;

import java.io.*;
import java.util.*;
import tudresden.ocl.parser.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("Unable to read lexer.dat.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new1(int line, int pos) { return new TDot(line, pos); }
    Token new2(int line, int pos) { return new TArrow(line, pos); }
    Token new3(int line, int pos) { return new TNot(line, pos); }
    Token new4(int line, int pos) { return new TMult(line, pos); }
    Token new5(int line, int pos) { return new TDiv(line, pos); }
    Token new6(int line, int pos) { return new TPlus(line, pos); }
    Token new7(int line, int pos) { return new TMinus(line, pos); }
    Token new8(int line, int pos) { return new TContext(line, pos); }
    Token new9(int line, int pos) { return new TEnum(line, pos); }
    Token new10(int line, int pos) { return new TTPre(line, pos); }
    Token new11(int line, int pos) { return new TTPost(line, pos); }
    Token new12(int line, int pos) { return new TTInv(line, pos); }
    Token new13(int line, int pos) { return new TEqual(line, pos); }
    Token new14(int line, int pos) { return new TNEqual(line, pos); }
    Token new15(int line, int pos) { return new TLt(line, pos); }
    Token new16(int line, int pos) { return new TGt(line, pos); }
    Token new17(int line, int pos) { return new TLteq(line, pos); }
    Token new18(int line, int pos) { return new TGteq(line, pos); }
    Token new19(int line, int pos) { return new TAnd(line, pos); }
    Token new20(int line, int pos) { return new TOr(line, pos); }
    Token new21(int line, int pos) { return new TXor(line, pos); }
    Token new22(int line, int pos) { return new TImplies(line, pos); }
    Token new23(int line, int pos) { return new TLPar(line, pos); }
    Token new24(int line, int pos) { return new TRPar(line, pos); }
    Token new25(int line, int pos) { return new TLBracket(line, pos); }
    Token new26(int line, int pos) { return new TRBracket(line, pos); }
    Token new27(int line, int pos) { return new TLBrace(line, pos); }
    Token new28(int line, int pos) { return new TRBrace(line, pos); }
    Token new29(int line, int pos) { return new TSemicolon(line, pos); }
    Token new30(int line, int pos) { return new TDcolon(line, pos); }
    Token new31(int line, int pos) { return new TColon(line, pos); }
    Token new32(int line, int pos) { return new TComma(line, pos); }
    Token new33(int line, int pos) { return new TChannel(line, pos); }
    Token new34(int line, int pos) { return new TAt(line, pos); }
    Token new35(int line, int pos) { return new TBar(line, pos); }
    Token new36(int line, int pos) { return new TDdot(line, pos); }
    Token new37(int line, int pos) { return new TApostroph(line, pos); }
    Token new38(int line, int pos) { return new TTLet(line, pos); }
    Token new39(int line, int pos) { return new TTIn(line, pos); }
    Token new40(int line, int pos) { return new TTIf(line, pos); }
    Token new41(int line, int pos) { return new TTThen(line, pos); }
    Token new42(int line, int pos) { return new TTElse(line, pos); }
    Token new43(int line, int pos) { return new TEndif(line, pos); }
    Token new44(String text, int line, int pos) { return new TTSet(text, line, pos); }
    Token new45(String text, int line, int pos) { return new TTBag(text, line, pos); }
    Token new46(String text, int line, int pos) { return new TTSequence(text, line, pos); }
    Token new47(String text, int line, int pos) { return new TTCollection(text, line, pos); }
    Token new48(String text, int line, int pos) { return new TBool(text, line, pos); }
    Token new49(String text, int line, int pos) { return new TSimpleTypeName(text, line, pos); }
    Token new50(String text, int line, int pos) { return new TName(text, line, pos); }
    Token new51(String text, int line, int pos) { return new TNewLine(text, line, pos); }
    Token new52(String text, int line, int pos) { return new TInt(text, line, pos); }
    Token new53(String text, int line, int pos) { return new TReal(text, line, pos); }
    Token new54(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new55(String text, int line, int pos) { return new TTab(text, line, pos); }
    Token new56(String text, int line, int pos) { return new TStringLit(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {35, 35, 5}, {39, 39, 6}, {40, 40, 7}, {41, 41, 8}, {42, 42, 9}, {43, 43, 10}, {44, 44, 11}, {45, 45, 12}, {46, 46, 13}, {47, 47, 14}, {48, 57, 15}, {58, 58, 16}, {59, 59, 17}, {60, 60, 18}, {61, 61, 19}, {62, 62, 20}, {64, 64, 21}, {65, 65, 22}, {66, 66, 23}, {67, 67, 24}, {68, 82, 22}, {83, 83, 25}, {84, 90, 22}, {91, 91, 26}, {93, 93, 27}, {97, 97, 28}, {98, 98, 29}, {99, 99, 30}, {100, 100, 29}, {101, 101, 31}, {102, 102, 32}, {103, 104, 29}, {105, 105, 33}, {106, 107, 29}, {108, 108, 34}, {109, 109, 29}, {110, 110, 35}, {111, 111, 36}, {112, 112, 37}, {113, 115, 29}, {116, 116, 38}, {117, 119, 29}, {120, 120, 39}, {121, 122, 29}, {123, 123, 40}, {124, 124, 41}, {125, 125, 42}, },
            {},
            {},
            {{10, 10, 43}, },
            {{32, 32, 4}, },
            {},
            {{0, 9, 44}, {11, 12, 44}, {14, 38, 44}, {39, 39, 45}, {40, 91, 44}, {92, 92, 46}, {93, 127, 44}, },
            {},
            {},
            {},
            {},
            {},
            {{45, 45, 47}, {62, 62, 48}, },
            {{46, 46, 49}, },
            {},
            {{46, 46, 50}, {48, 57, 15}, },
            {{58, 58, 51}, },
            {},
            {{61, 61, 52}, {62, 62, 53}, },
            {},
            {{61, 61, 54}, },
            {},
            {{48, 57, 55}, {65, 90, 56}, {95, 95, 57}, {97, 122, 58}, },
            {{48, 95, -24}, {97, 97, 59}, {98, 122, 58}, },
            {{48, 95, -24}, {97, 110, 58}, {111, 111, 60}, {112, 122, 58}, },
            {{48, 95, -24}, {97, 100, 58}, {101, 101, 61}, {102, 122, 58}, },
            {},
            {},
            {{48, 57, 62}, {65, 90, 63}, {95, 95, 64}, {97, 109, 65}, {110, 110, 66}, {111, 122, 65}, },
            {{48, 95, -30}, {97, 122, 65}, },
            {{48, 95, -30}, {97, 110, 65}, {111, 111, 67}, {112, 122, 65}, },
            {{48, 95, -30}, {97, 107, 65}, {108, 108, 68}, {109, 109, 65}, {110, 110, 69}, {111, 122, 65}, },
            {{48, 95, -30}, {97, 97, 70}, {98, 122, 65}, },
            {{48, 95, -30}, {97, 101, 65}, {102, 102, 71}, {103, 108, 65}, {109, 109, 72}, {110, 110, 73}, {111, 122, 65}, },
            {{48, 95, -30}, {97, 100, 65}, {101, 101, 74}, {102, 122, 65}, },
            {{48, 110, -32}, {111, 111, 75}, {112, 122, 65}, },
            {{48, 95, -30}, {97, 113, 65}, {114, 114, 76}, {115, 122, 65}, },
            {{48, 110, -32}, {111, 111, 77}, {112, 113, 65}, {114, 114, 78}, {115, 122, 65}, },
            {{48, 95, -30}, {97, 103, 65}, {104, 104, 79}, {105, 113, 65}, {114, 114, 80}, {115, 122, 65}, },
            {{48, 110, -32}, {111, 111, 81}, {112, 122, 65}, },
            {},
            {},
            {},
            {},
            {{0, 127, -8}, },
            {},
            {{34, 34, 82}, {39, 39, 83}, {48, 55, 84}, {63, 63, 85}, {92, 92, 86}, {97, 97, 87}, {98, 98, 88}, {102, 102, 89}, {110, 110, 90}, {114, 114, 91}, {116, 116, 92}, {118, 118, 93}, {120, 120, 94}, },
            {{0, 9, 95}, {10, 10, 96}, {11, 12, 95}, {13, 13, 96}, {14, 127, 95}, },
            {},
            {},
            {{48, 57, 97}, },
            {},
            {},
            {},
            {},
            {{48, 122, -24}, },
            {{48, 122, -24}, },
            {{48, 122, -24}, },
            {{48, 122, -24}, },
            {{48, 95, -24}, {97, 102, 58}, {103, 103, 98}, {104, 122, 58}, },
            {{48, 95, -24}, {97, 107, 58}, {108, 108, 99}, {109, 122, 58}, },
            {{48, 95, -24}, {97, 112, 58}, {113, 113, 100}, {114, 115, 58}, {116, 116, 101}, {117, 122, 58}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 95, -30}, {97, 99, 65}, {100, 100, 102}, {101, 122, 65}, },
            {{48, 109, -30}, {110, 110, 103}, {111, 122, 65}, },
            {{48, 95, -30}, {97, 114, 65}, {115, 115, 104}, {116, 122, 65}, },
            {{48, 99, -68}, {100, 100, 105}, {101, 116, 65}, {117, 117, 106}, {118, 122, 65}, },
            {{48, 107, -33}, {108, 108, 107}, {109, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 95, -30}, {97, 111, 65}, {112, 112, 108}, {113, 122, 65}, },
            {{48, 95, -30}, {97, 117, 65}, {118, 118, 109}, {119, 122, 65}, },
            {{48, 95, -30}, {97, 115, 65}, {116, 116, 110}, {117, 122, 65}, },
            {{48, 115, -76}, {116, 116, 111}, {117, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 114, -70}, {115, 115, 112}, {116, 122, 65}, },
            {{48, 100, -36}, {101, 101, 113}, {102, 122, 65}, },
            {{48, 100, -36}, {101, 101, 114}, {102, 122, 65}, },
            {{48, 95, -30}, {97, 116, 65}, {117, 117, 115}, {118, 122, 65}, },
            {{48, 113, -38}, {114, 114, 116}, {115, 122, 65}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 39, -8}, {40, 47, 44}, {48, 55, 117}, {56, 91, 44}, {92, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{48, 57, 118}, {65, 70, 118}, {97, 102, 118}, },
            {{0, 127, -49}, },
            {},
            {{48, 57, 97}, },
            {{48, 122, -24}, },
            {{48, 107, -62}, {108, 108, 119}, {109, 122, 58}, },
            {{48, 95, -24}, {97, 116, 58}, {117, 117, 120}, {118, 122, 58}, },
            {{48, 122, -24}, },
            {{48, 122, -31}, },
            {{48, 115, -76}, {116, 116, 121}, {117, 122, 65}, },
            {{48, 100, -36}, {101, 101, 122}, {102, 122, 65}, },
            {{48, 95, -30}, {97, 104, 65}, {105, 105, 123}, {106, 122, 65}, },
            {{48, 95, -30}, {97, 108, 65}, {109, 109, 124}, {110, 122, 65}, },
            {{48, 114, -70}, {115, 115, 125}, {116, 122, 65}, },
            {{48, 107, -33}, {108, 108, 126}, {109, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 115, -76}, {116, 116, 127}, {117, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 109, -30}, {110, 110, 128}, {111, 122, 65}, },
            {{48, 100, -36}, {101, 101, 129}, {102, 122, 65}, },
            {{48, 122, -31}, },
            {{0, 47, -86}, {48, 55, 130}, {56, 127, -86}, },
            {{0, 47, -86}, {48, 57, 131}, {58, 64, 44}, {65, 70, 131}, {71, 91, 44}, {92, 92, 46}, {93, 96, 44}, {97, 102, 131}, {103, 127, 44}, },
            {{48, 100, -27}, {101, 101, 132}, {102, 122, 58}, },
            {{48, 100, -27}, {101, 101, 133}, {102, 122, 58}, },
            {{48, 100, -36}, {101, 101, 134}, {102, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 101, -35}, {102, 102, 135}, {103, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 100, -36}, {101, 101, 136}, {102, 122, 65}, },
            {{48, 104, -107}, {105, 105, 137}, {106, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{0, 127, -8}, },
            {{0, 127, -120}, },
            {{48, 95, -24}, {97, 98, 58}, {99, 99, 138}, {100, 122, 58}, },
            {{48, 95, -24}, {97, 109, 58}, {110, 110, 139}, {111, 122, 58}, },
            {{48, 95, -30}, {97, 119, 65}, {120, 120, 140}, {121, 122, 65}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 100, -36}, {101, 101, 141}, {102, 122, 65}, },
            {{48, 95, -24}, {97, 115, 58}, {116, 116, 142}, {117, 122, 58}, },
            {{48, 98, -134}, {99, 99, 143}, {100, 122, 58}, },
            {{48, 115, -76}, {116, 116, 144}, {117, 122, 65}, },
            {{48, 114, -70}, {115, 115, 145}, {116, 122, 65}, },
            {{48, 95, -24}, {97, 104, 58}, {105, 105, 146}, {106, 122, 58}, },
            {{48, 100, -27}, {101, 101, 147}, {102, 122, 58}, },
            {{48, 122, -31}, },
            {{48, 122, -31}, },
            {{48, 110, -26}, {111, 111, 148}, {112, 122, 58}, },
            {{48, 122, -24}, },
            {{48, 109, -135}, {110, 110, 149}, {111, 122, 58}, },
            {{48, 122, -24}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {54, 54, 51, 51, 54, 33, 37, 23, 24, 4, 6, 32, 7, 1, 5, 52, 31, 29, 15, 13, 16, 34, 49, 49, 49, 49, 25, 26, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 27, 35, 28, 51, -1, 56, -1, 0, 2, 36, -1, 30, 17, 14, 18, 49, 49, 49, 49, 49, 49, 49, 50, 50, 50, 50, 50, 50, 50, 50, 50, 40, 50, 39, 50, 50, 20, 50, 50, 50, 50, 50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, 53, 45, 49, 49, 44, 19, 50, 50, 50, 50, 50, 50, 12, 38, 3, 50, 10, 50, 50, 21, -1, -1, 49, 49, 50, 42, 50, 9, 50, 50, 11, 41, 48, -1, -1, 49, 49, 50, 43, 48, 50, 49, 49, 50, 50, 49, 49, 8, 22, 49, 46, 49, 47, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}

